/**
 * 度数の検定
 * ２×２表(Fisher's exact test)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
//セルデータの消去
function clearCellData() {
	var i = 1;
	var elmCount = 4;

	var result = confirm("データを消去します");
	if (result === true) {
		for (i = 1; i < 5; i++) {
			document.getElementById("cell_" + i).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("cell_sum").value = "";
		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	document.getElementById("cell_1").focus();
}
//入力チェック
function checkCellData() {
	var i = 1;
	var iCount = 2;
	var jCount = 2;
	var elmCount = iCount * jCount;

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 1; i < elmCount + 1; i++) {
			if (document.getElementById("cell_" + i).value === "") {
				errorCellNum = i;
			}
		}

		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			sum();
			mainCalc_2x2();
		} else {
			alert("すべての度数が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		conditionalBranch();
		copipe("CandPArea", "text");
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
		sum();
		checkCellData();
	}
}
// スタック形式ならクロス集計に分岐
function conditionalBranch() {
	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	if (dd.length > 2 * 2) {
		crossTabulate();
	}
}
//スタック形式をクロス集計する
function crossTabulate() {
	var i = 0;
	var j = 0;

	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var err = false;

	var NN = countRowCol("CandPArea")[0]; // 行数を取得
	var KK = countRowCol("CandPArea")[1]; // 列数を取得

	// if (dd.length % 2 !== 0) { //データ個数が偶数であること
	// 	err = true;
	// }

	if (NN === 2) {
		err = true;
	}

	if (KK === -1) { //データが行列形式でない
		err = true;
	}

	if (err === false) {
		for (i = 0; i < dd.length; i++) {
			if (isNaN(dd[i]) === false) {
				if ((parseInt(dd[i]) == 1) || (parseInt(dd[i]) == 2)) {
					err = false;
				} else {
					err = true;
					break;
				}
			}
		}

		if (err === false) {
			var groupValue = new Array(2);
			for (i = 0; i < 2; i++) {
				groupValue[i] = new Array(2);
			}

			for (i = 0; i < 2; i++) {
				for (j = 0; j < 2; j++) {
					groupValue[i][j] = 0;
				}
			}

			for (i = 0; i < dd.length; i = i + 2) {
				groupValue[dd[i] - 1][dd[i + 1] - 1]++;
			}

			var strArray = [];
			for (i = 0; i < 2; i++) {
				for (j = 0; j < 2; j++) {
					strArray.push(groupValue[i][j]);
					strArray.push("\t");
				}
				strArray.push("\n");
			}
			document.getElementById("CandPArea").value = strArray.join("");
		} else {
			document.getElementById("CandPArea").value = "";
			alert("データ形式が正しくありません。");
		}
	} else {
		document.getElementById("CandPArea").value = "";
		alert("データ形式が正しくありません。");
	}
}
//メインの計算
function mainCalc_2x2() {
	var i = 0;
	var DD1 = parseInt(document.getElementById("cell_1").value);
	var DD2 = parseInt(document.getElementById("cell_2").value);
	var DD3 = parseInt(document.getElementById("cell_3").value);
	var DD4 = parseInt(document.getElementById("cell_4").value);

	var A = DD1;
	var B = DD2;
	var C = DD3;
	var D = DD4;

	var M1 = A + B; //  A   B  | M1
	var M2 = C + D; //  C   D  | M2
	var M3 = B + D; //---------+----
	var M4 = A + C; //  M4  M3 | NN

	var NN = A + B + C + D;
	document.getElementById("cell_sum").value = NN;

	var svA = A; //A～Dの値を保存(save)しておく
	var svB = B;
	var svC = C;
	var svD = D;

	var raA = (A / (A + B)).toFixed(4);  //A～Dの比率(ratio)
	var raB = (B / (A + B)).toFixed(4);
	var raC = (C / (C + D)).toFixed(4);
	var raD = (D / (C + D)).toFixed(4);

	var PP2 = 0; //両側確率
	var PP = 0;  //片側確率
	var K1 = 0;  //片側確率(計算１)
	var K2 = 0;  //片側確率(計算２)
	var wPP = []; //それぞれの場合のP値
	var KS = []; //交差 A*C-B*D

	var strArray = [];
	var rcmArray = [];

	var Dummy = 0;
	while ((M2 < M1) || (M3 < M1) || (M4 < M1)) { //M1が一番小さくなるまでABCDの値を変更する
		Dummy = A;
		A = B;
		B = Dummy;

		Dummy = A;
		A = D;
		D = Dummy;

		Dummy = A;
		A = C;
		C = Dummy;

		M1 = A + B;
		M2 = C + D;
		M3 = B + D;
		M4 = A + C;
	}

	var AA = A; //Aの値を保存しておく

	var LT = []; //logの値を代入して計算を高速化する
	var maxM = Math.max(M1, M2, M3, M4);
	for (i = 0; i < maxM + 1; i++) {
		LT[i] = logfact(i);
	}
	LT[NN] = logfact(NN);

	var iA, iB, iC, iD;
	var myConst = LT[M1] + LT[M2] + LT[M3] + LT[M4] - LT[NN];
	for (iA = 0; iA < M1 + 1; iA++) {
		iB = M1 - iA;
		iC = M4 - iA;
		iD = M3 - iB;
		KS[iA] = iA * iD - iB * iC;
		wPP[iA] = Math.exp(myConst - LT[iA] - LT[iB] - LT[iC] - LT[iD]);
		wPP[iA] = wPP[iA] * 1000000000000000; //計算結果が16桁目に誤差がでるのを防ぐ
		wPP[iA] = Math.round(wPP[iA]);
		wPP[iA] = wPP[iA] / 1000000000000000;
	}

	for (iA = 0; iA < M1 + 1; iA++) {
		if (wPP[iA] <= wPP[AA]) {
			PP2 = PP2 + wPP[iA];
		}
		//交差で判断
		if (KS[AA] <= KS[iA]) {
			K1 = K1 + wPP[iA];
		}
		if (KS[AA] >= KS[iA]) {
			K2 = K2 + wPP[iA];
		}
	}

	var ppStr = "";
	if (PP2 < 0.01) {
		ppStr = "   ** (p<.01)";
	} else if (PP2 < 0.05) {
		ppStr = "   *  (p<.05)";
	} else if (PP2 < 0.10) {
		ppStr = "   +  (.05<p<.10)";
	} else {
		ppStr = "   ns (.10<p)";
	}

	strArray.push("[直接確率計算２×２]\n\n");
	strArray.push("\t観測値１\t観測値２\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("群１\t" + DD1 + "\t" + DD2 + "\n");
	strArray.push("\t" + "(" + raA + ")" + "\t" + "(" + raB + ")" + "\n");
	strArray.push("群２\t" + DD3 + "\t" + DD4 + "\n");
	strArray.push("\t" + "(" + raC + ")" + "\t" + "(" + raD + ")" + "\n");
	strArray.push("-----------------------------------------" + "\n\n");
	strArray.push("両側検定  :  p=" + PP2.toFixed(4) + ppStr + "\n");

	if (K1 < K2) {
		PP = K1;
	} else {
		PP = K2;
	}

	var pp2Str = "";
	if (PP < 0.01) {
		pp2Str = "   ** (p<.01)";
	} else if (PP < 0.05) {
		pp2Str = "   *  (p<.05)";
	} else if (PP < 0.10) {
		pp2Str = "   +  (.05<p<.10)";
	} else {
		pp2Str = "   ns (.10<p)";
	}

	strArray.push("片側検定  :  p=" + PP.toFixed(4) + pp2Str + "\n\n");

	//Phiの計算（常に出力する）
	M1 = svA + svB;
	M2 = svC + svD;
	M3 = svA + svC;
	M4 = svB + svD;

	var Phi = Math.sqrt(Math.pow(svA * svD - svB * svC, 2) / (M1 * M2 * M3 * M4));
	var phi = Phi.toFixed(3);

	strArray.push("連関係数 : Phi=" + phi + "\n");

	//効果量の計算（常に出力する）
	var effectSizeH = 2 * Math.asin(Math.sqrt(raA)) - 2 * Math.asin(Math.sqrt(raC));
	strArray.push("効果量 : h=" + effectSizeH.toFixed(4) + "\n");
	strArray.push("\t\t（大=0.8 , 中=0.5 , 小=0.2）\n");

	strArray.push("-----------------------------------------\n");

	//オッズ比計算
	strArray.push("\n");
	strArray.push("[オッズ比検定]\n\n");
	strArray.push("\t観測値１\t観測値２\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("群１\t" + svA + "\t" + svB + "\n");
	strArray.push("群２\t" + svC + "\t" + svD + "\n");
	strArray.push("-----------------------------------------" + "\n\n");

	if ((svA === 0) || (svB === 0) || (svC === 0) || (svD === 0)) {
		svA = svA + 0.5;
		svB = svB + 0.5;
		svC = svC + 0.5;
		svD = svD + 0.5;

		strArray.push("＜修正値＞\n");
		strArray.push("\t観測値１\t観測値２\n");
		strArray.push("-----------------------------------------\n");
		strArray.push("群１\t" + svA + "\t" + svB + "\n");
		strArray.push("群２\t" + svC + "\t" + svD + "\n");
		strArray.push("-----------------------------------------" + "\n");
		strArray.push("観測値に０があったので,＋0.5で修正しました。\n\n");
	}

	//NN = A+B+C+D;

	var os;
	var se;
	var kagen;
	var jogen;
	var hantei;

	os = (svA * svD) / (svB * svC);
	se = Math.sqrt(1 / svA + 1 / svB + 1 / svC + 1 / svD);
	kagen = os * Math.exp(-1.96 * se); //両側検定
	jogen = os * Math.exp(1.96 * se);

	hantei = "有意でない";
	if ((kagen < 1) && (jogen < 1)) {
		hantei = "有意である";
	}
	if ((kagen > 1) && (jogen > 1)) {
		hantei = "有意である";
	}

	strArray.push("オッズ比:  =" + using(os, 4, 2) + "\n\n");
	strArray.push("＜両側検定＞\n");
	strArray.push("下限値  :  =" + using(kagen, 4, 2) + "\n");
	strArray.push("上限値  :  =" + using(jogen, 4, 2) + "\n");
	strArray.push("オッズ比による検定は," + hantei + "(95%信頼区間,両側)\n");

	if (os < 1) { //片側検定
		kagen = 0;
		jogen = os * Math.exp(1.645 * se);
	} else {
		kagen = os * Math.exp(-1.645 * se);
		jogen = "∞";
	}

	hantei = "有意でない";
	if (jogen < 1) {
		hantei = "有意である";
	}
	if (kagen > 1) {
		hantei = "有意である";
	}

	strArray.push("\n");
	strArray.push("＜片側検定＞\n");

	if (os < 1) {
		strArray.push("下限値  :  =" + using(kagen, 4, 2) + "\n");
		strArray.push("上限値  :  =" + using(jogen, 4, 2) + "\n");
	} else {
		strArray.push("下限値  :  =" + using(kagen, 4, 2) + "\n");
		strArray.push("上限値  :  = ∞\n");
	}

	strArray.push("オッズ比による検定は," + hantei + "(95%信頼区間,片側)\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	//出力
	if (document.getElementById("RltAdd").checked) {
		document.getElementById("RltArea").value += "\n\n" + strArray.join("");
	} else {
		document.getElementById("RltArea").value = strArray.join("");
	}
	strArray = null;

	//Ｒプログラム出力
	(function () {
		rcmArray.push("####### ２×２表(Fisher's exact test) #######\n");
		rcmArray.push("\n");
		rcmArray.push("# パッケージ pwr が必要\n");
		rcmArray.push("\n");
		rcmArray.push("## js-STARからの入力\n");
		rcmArray.push("ds11=" + DD1 + "  # 群１の値１\n");
		rcmArray.push("ds12=" + DD2 + "  # 群１の値２\n");
		rcmArray.push("ds21=" + DD3 + "  # 群２\n");
		rcmArray.push("ds22=" + DD4 + "\n");
		rcmArray.push("\n");
		rcmArray.push("shinrai=0.95\n");
		rcmArray.push("## js-STARからの入力おわり\n");
		rcmArray.push("\n");
		rcmArray.push("gun1 <- c(ds11, ds12)\n");
		rcmArray.push("gun2 <- c(ds21, ds22)\n");
		rcmArray.push("N    <- ds11+ds12+ds21+ds22\n");
		rcmArray.push("n1   <- sum(gun1)\n");
		rcmArray.push("n2   <- sum(gun2)\n");
		rcmArray.push("tx1  <- matrix(c(\n");
		rcmArray.push("  ds11,ds12, ds11/n1,\n");
		rcmArray.push("  ds21,ds22, ds21/n2\n");
		rcmArray.push("  ), nr=2, by=1)\n");
		rcmArray.push("rownames(tx1) <- c(\"群１\",\"群２\")\n");
		rcmArray.push("colnames(tx1) <- c(\"値１\",\" 値２\",\" 値１の比率\")\n");
		rcmArray.push("\n");
		rcmArray.push("## 図を描く\n");
		rcmArray.push("zhyo <- matrix( c(\n");
		rcmArray.push("  gun2/ n2,                  # 群２を先に\n");
		rcmArray.push("  gun1/ n1 ), nc=2, by=1)    # 群１をあと\n");
		rcmArray.push("rownames(zhyo) <- c(\"群２\", \"群１\") # 群２が先！\n");
		rcmArray.push("maintitle <- c(\"値１（黒）と値２（灰白）の比率\")\n");
		rcmArray.push("barplot( t(zhyo), hor=1, main=maintitle,\n");
		rcmArray.push("         las=1, cex.ax=1.5, cex.na=1.5 )\n");
		rcmArray.push("\n");
		rcmArray.push("## ここから統計分析\n");
		rcmArray.push("library( pwr )       # パワーアナリシス\n");
		rcmArray.push("P1 <- c( ds11/ n1 )  # 群１の値１の比率\n");
		rcmArray.push("P2 <- c( ds21/ n2 )  # 群２の値１\n");
		rcmArray.push("es <- ES.h( P1, P2 ) # 効果量ｈ\n");
		rcmArray.push("hyo <- matrix(c(\n");
		rcmArray.push("  ds11,ds12,\n");
		rcmArray.push("  ds21,ds22), nr=2, by=1)\n");
		rcmArray.push("odd <- (ds11/ds12)/(ds21/ds22) # オッズ比\n");
		rcmArray.push("err <- sqrt(\n");
		rcmArray.push("  1/ds11+1/ds12+1/ds21+1/ds22  # 標準誤差\n");
		rcmArray.push("  )\n");
		rcmArray.push("\n");
		rcmArray.push("## ■片側grater\n");
		rcmArray.push("H1  <- c(\"g\")\n");
		rcmArray.push("\n");
		rcmArray.push("kFS <- c()\n");
		rcmArray.push("kPR <- c()\n");
		rcmArray.push("kFS <- fisher.test(hyo,al=H1,\n");
		rcmArray.push("  conf.lev=shinrai)\n");
		rcmArray.push("kPR <- prop.test(hyo,  al=H1,\n");
		rcmArray.push("  conf.lev=shinrai)\n");
		rcmArray.push("\n");
		rcmArray.push("tg1 <- c()\n");
		rcmArray.push("tg1 <- matrix(c(\n");
		rcmArray.push("  round(kFS$p.va, 4)\n");
		rcmArray.push("  ), nr=1)\n");
		rcmArray.push("rownames(tg1) <- c(\n");
		rcmArray.push("  \"片側greater\" )\n");
		rcmArray.push("colnames(tg1) <- c(\n");
		rcmArray.push("  \"    ｐ値\" )\n");
		rcmArray.push("\n");
		rcmArray.push("kPW <- NA\n");
		rcmArray.push("kPW <- pwr.2p2n.test(\n");
		rcmArray.push("  h=es,\n");
		rcmArray.push("  n1=n1, n2=n2,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=NULL,\n");
		rcmArray.push("  al=H1   )$po\n");
		rcmArray.push("\n");
		rcmArray.push("tg2 <- c()\n");
		rcmArray.push("tg2 <- matrix(c(\n");
		rcmArray.push("  round(kPR$stat, 4),\n");
		rcmArray.push("        kPR$para,\n");
		rcmArray.push("  round(kPR$p.va, 4),\n");
		rcmArray.push("  round(es,       4),\n");
		rcmArray.push("  round(kPW,      4)\n");
		rcmArray.push("   ), nr=1 )\n");
		rcmArray.push("rownames(tg2) <- c(\n");
		rcmArray.push("  \"片側greater\" )\n");
		rcmArray.push("colnames(tg2) <- c(\n");
		rcmArray.push("  \" χ2 値\",\n");
		rcmArray.push("  \" df\",\n");
		rcmArray.push("  \"  ｐ値\",\n");
		rcmArray.push("  \" 効果量ｈ\",\n");
		rcmArray.push("  \" 検出力\" )\n");
		rcmArray.push("\n");
		rcmArray.push("# 信頼区間\n");
		rcmArray.push("tg3  <- c()\n");
		rcmArray.push("zten <- -1.645+(1.645-1.282)*sign(0.95-shinrai)\n");
		rcmArray.push("tg3  <- matrix(c(\n");
		rcmArray.push("  round(ds11/n1-ds21/n2,  4),\n");
		rcmArray.push("  round(kPR$conf[c(1,2)], 4),\n");
		rcmArray.push("  round(odd, 4),\n");
		rcmArray.push("  round(odd*exp(zten*err), 4),\n");
		rcmArray.push("  Inf\n");
		rcmArray.push("  ), nr=2, by=1)\n");
		rcmArray.push("rownames(tg3) <- c(\n");
		rcmArray.push("  \"比率の差\",\n");
		rcmArray.push("  \"オッズ比\")\n");
		rcmArray.push("colnames(tg3) <- c(\n");
		rcmArray.push("  \" 点推定\",\n");
		rcmArray.push("  paste(\" \",\n");
		rcmArray.push("    paste(shinrai*100,\"％信頼下限値\",sep=\"\"),\n");
		rcmArray.push("    sep=\"\"),\n");
		rcmArray.push("  \" 上限値\")\n");
		rcmArray.push("\n");
		rcmArray.push("# パワアナ\n");
		rcmArray.push("tmp <- NA\n");
		rcmArray.push("kNN <- pwr.2p2n.test( al=H1,\n");
		rcmArray.push("  h=es, n1=n1,  n2=NULL, si=0.05, po=0.80)\n");
		rcmArray.push("tmp <- ceiling( (n1+kNN$n2)/2 )\n");
		rcmArray.push("kNN <- pwr.2p2n.test( al=H1,\n");
		rcmArray.push("  h=es, n1=tmp, n2=NULL, si=0.05, po=0.80)\n");
		rcmArray.push("tmp <- ceiling( (tmp+kNN$n2)/2 )\n");
		rcmArray.push("kNN <- pwr.2p2n.test( al=H1,\n");
		rcmArray.push("  h=es, n1=tmp, n2=NULL, si=0.05, po=0.80)\n");
		rcmArray.push("tmp <- ceiling( (tmp+kNN$n2)/2 )\n");
		rcmArray.push("kNN <- pwr.2p2n.test( al=H1,\n");
		rcmArray.push("  h=es, n1=tmp, n2=NULL, si=0.05, po=0.80)\n");
		rcmArray.push("tmp <- c(\n");
		rcmArray.push("  ceiling( (tmp+kNN$n2)/2 ),\n");
		rcmArray.push("  tmp)\n");
		rcmArray.push("kNN <- NA\n");
		rcmArray.push("kNN <- c(\n");
		rcmArray.push("  pwr.2p2n.test( al=H1,\n");
		rcmArray.push("  h=es,\n");
		rcmArray.push("  n1=tmp[1], n2=NULL,\n");
		rcmArray.push("  si=0.05, po=0.80)$n2,\n");
		rcmArray.push("  kNN)\n");
		rcmArray.push("\n");
		rcmArray.push("kSi <- c()\n");
		rcmArray.push("kSi <- pwr.2p2n.test( al=H1,\n");
		rcmArray.push("  h=es, n1=n1, n2=n2,\n");
		rcmArray.push("  si=NULL, po=0.80)$si\n");
		rcmArray.push("\n");
		rcmArray.push("tg4 <- c()\n");
		rcmArray.push("tg4 <- data.frame( matrix(c(\n");
		rcmArray.push("  round(es,  4),\n");
		rcmArray.push("  round(kSi, 4),\n");
		rcmArray.push("       0.80,\n");
		rcmArray.push("         n1,\n");
		rcmArray.push("         n2,\n");
		rcmArray.push("\n");
		rcmArray.push("  round(es,  4),\n");
		rcmArray.push("      0.05,\n");
		rcmArray.push("      0.80,\n");
		rcmArray.push("    tmp[1],\n");
		rcmArray.push("  ceiling(kNN[1])\n");
		rcmArray.push("  ), nr=2, by=1) )\n");
		rcmArray.push("rownames(tg4) <- c(\n");
		rcmArray.push("  \" α の計算\",\n");
		rcmArray.push("  \" ｎ の計算\" )\n");
		rcmArray.push("colnames(tg4) <- c(\n");
		rcmArray.push("  \"効果量ｈ\",\n");
		rcmArray.push("  \"   α\",\n");
		rcmArray.push("  \" 1-β\",\n");
		rcmArray.push("  \"  n1\",\n");
		rcmArray.push("  \"  n2\" )\n");
		rcmArray.push("\n");
		rcmArray.push("## ■片側less\n");
		rcmArray.push("H1  <- c(\"l\")\n");
		rcmArray.push("\n");
		rcmArray.push("kFS <- c()\n");
		rcmArray.push("kPR <- c()\n");
		rcmArray.push("kFS <- fisher.test(hyo,al=H1,\n");
		rcmArray.push("  conf.lev=shinrai)\n");
		rcmArray.push("kPR <- prop.test(hyo,  al=H1,\n");
		rcmArray.push("  conf.lev=shinrai)\n");
		rcmArray.push("\n");
		rcmArray.push("tl1 <- c()\n");
		rcmArray.push("tl1 <- matrix(c(\n");
		rcmArray.push("  round(kFS$p.va, 4)\n");
		rcmArray.push("  ), nr=1)\n");
		rcmArray.push("rownames(tl1) <- c(\n");
		rcmArray.push("  \"片側less\" )\n");
		rcmArray.push("colnames(tl1) <- c(\n");
		rcmArray.push("  \"    ｐ値\" )\n");
		rcmArray.push("\n");
		rcmArray.push("kPW <- NA\n");
		rcmArray.push("kPW <- pwr.2p2n.test(\n");
		rcmArray.push("  h=es,\n");
		rcmArray.push("  n1=n1, n2=n2,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=NULL,\n");
		rcmArray.push("  al=H1   )$po\n");
		rcmArray.push("\n");
		rcmArray.push("tl2 <- c()\n");
		rcmArray.push("tl2 <- matrix(c(\n");
		rcmArray.push("  round(kPR$stat, 4),\n");
		rcmArray.push("        kPR$para,\n");
		rcmArray.push("  round(kPR$p.va, 4),\n");
		rcmArray.push("  round(es,       4),\n");
		rcmArray.push("  round(kPW,      4)\n");
		rcmArray.push("   ), nr=1 )\n");
		rcmArray.push("rownames(tl2) <- c(\n");
		rcmArray.push("  \"片側less\" )\n");
		rcmArray.push("colnames(tl2) <- c(\n");
		rcmArray.push("  \" χ2 値\",\n");
		rcmArray.push("  \" df\",\n");
		rcmArray.push("  \"  ｐ値\",\n");
		rcmArray.push("  \" 効果量ｈ\",\n");
		rcmArray.push("  \" 検出力\" )\n");
		rcmArray.push("\n");
		rcmArray.push("# 信頼区間\n");
		rcmArray.push("tl3  <- c()\n");
		rcmArray.push("zten <- 1.645+(-1.645+1.282)*sign(0.95-shinrai)\n");
		rcmArray.push("tl3  <- matrix(c(\n");
		rcmArray.push("  round(ds11/n1-ds21/n2,  4),\n");
		rcmArray.push("  round(kPR$conf[c(1,2)], 4),\n");
		rcmArray.push("  round(odd, 4),\n");
		rcmArray.push("              0,\n");
		rcmArray.push("  round(odd*exp(zten*err), 4)\n");
		rcmArray.push("  ), nr=2, by=1)\n");
		rcmArray.push("rownames(tl3) <- c(\n");
		rcmArray.push("  \"比率の差\",\n");
		rcmArray.push("  \"オッズ比\")\n");
		rcmArray.push("colnames(tl3) <- c(\n");
		rcmArray.push("  \" 点推定\",\n");
		rcmArray.push("  paste(\" \",\n");
		rcmArray.push("    paste(shinrai*100,\"％信頼下限値\",sep=\"\"),\n");
		rcmArray.push("    sep=\"\"),\n");
		rcmArray.push("  \" 上限値\")\n");
		rcmArray.push("\n");
		rcmArray.push("# パワアナ\n");
		rcmArray.push("tmp <- NA\n");
		rcmArray.push("kNN <- pwr.2p2n.test( al=H1,\n");
		rcmArray.push("  h=es, n1=n1,  n2=NULL, si=0.05, po=0.80)\n");
		rcmArray.push("tmp <- ceiling( (n1+kNN$n2)/2 )\n");
		rcmArray.push("kNN <- pwr.2p2n.test( al=H1,\n");
		rcmArray.push("  h=es, n1=tmp, n2=NULL, si=0.05, po=0.80)\n");
		rcmArray.push("tmp <- ceiling( (tmp+kNN$n2)/2 )\n");
		rcmArray.push("kNN <- pwr.2p2n.test( al=H1,\n");
		rcmArray.push("  h=es, n1=tmp, n2=NULL, si=0.05, po=0.80)\n");
		rcmArray.push("tmp <- ceiling( (tmp+kNN$n2)/2 )\n");
		rcmArray.push("kNN <- pwr.2p2n.test( al=H1,\n");
		rcmArray.push("  h=es, n1=tmp, n2=NULL, si=0.05, po=0.80)\n");
		rcmArray.push("tmp <- c(\n");
		rcmArray.push("  ceiling( (tmp+kNN$n2)/2 ),\n");
		rcmArray.push("  tmp)\n");
		rcmArray.push("kNN <- NA\n");
		rcmArray.push("kNN <- c(\n");
		rcmArray.push("  pwr.2p2n.test( al=H1,\n");
		rcmArray.push("  h=es,\n");
		rcmArray.push("  n1=tmp[1], n2=NULL,\n");
		rcmArray.push("  si=0.05, po=0.80)$n2,\n");
		rcmArray.push("  kNN)\n");
		rcmArray.push("\n");
		rcmArray.push("kSi <- c()\n");
		rcmArray.push("kSi <- pwr.2p2n.test( al=H1,\n");
		rcmArray.push("  h=es, n1=n1, n2=n2,\n");
		rcmArray.push("  si=NULL, po=0.80)$si\n");
		rcmArray.push("\n");
		rcmArray.push("tl4 <- c()\n");
		rcmArray.push("tl4 <- data.frame( matrix(c(\n");
		rcmArray.push("  round(es,  4),\n");
		rcmArray.push("  round(kSi, 4),\n");
		rcmArray.push("       0.80,\n");
		rcmArray.push("         n1,\n");
		rcmArray.push("         n2,\n");
		rcmArray.push("\n");
		rcmArray.push("  round(es,  4),\n");
		rcmArray.push("      0.05,\n");
		rcmArray.push("      0.80,\n");
		rcmArray.push("    tmp[1],\n");
		rcmArray.push("  ceiling(kNN[1])\n");
		rcmArray.push("  ), nr=2, by=1) )\n");
		rcmArray.push("rownames(tl4) <- c(\n");
		rcmArray.push("  \" α の計算\",\n");
		rcmArray.push("  \" ｎ の計算\" )\n");
		rcmArray.push("colnames(tl4) <- c(\n");
		rcmArray.push("  \"効果量ｈ\",\n");
		rcmArray.push("  \"   α\",\n");
		rcmArray.push("  \" 1-β\",\n");
		rcmArray.push("  \"  n1\",\n");
		rcmArray.push("  \"  n2\" )\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("# ■両側\n");
		rcmArray.push("H1  <- c(\"t\")\n");
		rcmArray.push("\n");
		rcmArray.push("kFS <- c()\n");
		rcmArray.push("kPR <- c()\n");
		rcmArray.push("kFS <- fisher.test(hyo,al=H1,\n");
		rcmArray.push("  conf.lev=shinrai)\n");
		rcmArray.push("kPR <- prop.test(hyo,  al=H1,\n");
		rcmArray.push("  conf.lev=shinrai)\n");
		rcmArray.push("\n");
		rcmArray.push("tr1 <- c()\n");
		rcmArray.push("tr1 <- matrix(c(\n");
		rcmArray.push("  round(kFS$p.va, 4)\n");
		rcmArray.push("  ), nr=1)\n");
		rcmArray.push("rownames(tr1) <- c(\n");
		rcmArray.push("  \"両側検定\" )\n");
		rcmArray.push("colnames(tr1) <- c(\n");
		rcmArray.push("  \"    ｐ値\" )\n");
		rcmArray.push("\n");
		rcmArray.push("kPW <- NA\n");
		rcmArray.push("kPW <- pwr.2p2n.test(\n");
		rcmArray.push("  h=es,\n");
		rcmArray.push("  n1=n1, n2=n2,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=NULL,\n");
		rcmArray.push("  al=H1   )$po\n");
		rcmArray.push("\n");
		rcmArray.push("tr2 <- c()\n");
		rcmArray.push("tr2 <- matrix(c(\n");
		rcmArray.push("  round(kPR$stat, 4),\n");
		rcmArray.push("        kPR$para,\n");
		rcmArray.push("  round(kPR$p.va, 4),\n");
		rcmArray.push("  round(es,       4),\n");
		rcmArray.push("  round(kPW,      4)\n");
		rcmArray.push("   ), nr=1 )\n");
		rcmArray.push("rownames(tr2) <- c(\n");
		rcmArray.push("  \"両側検定\" )\n");
		rcmArray.push("colnames(tr2) <- c(\n");
		rcmArray.push("  \" χ2 値\",\n");
		rcmArray.push("  \" df\",\n");
		rcmArray.push("  \"  ｐ値\",\n");
		rcmArray.push("  \" 効果量ｈ\",\n");
		rcmArray.push("  \" 検出力\" )\n");
		rcmArray.push("\n");
		rcmArray.push("# 信頼区間\n");
		rcmArray.push("tr3  <- c()\n");
		rcmArray.push("zten <- 1.96+(-1.96+1.645)*sign(0.95-shinrai)\n");
		rcmArray.push("tr3  <- matrix(c(\n");
		rcmArray.push("  round(ds11/n1-ds21/n2,  4),\n");
		rcmArray.push("  round(kPR$conf[c(1,2)], 4),\n");
		rcmArray.push("  round(odd, 4),\n");
		rcmArray.push("  round(odd*exp(-zten*err), 4),\n");
		rcmArray.push("  round(odd*exp( zten*err), 4)\n");
		rcmArray.push("  ), nr=2, by=1)\n");
		rcmArray.push("rownames(tr3) <- c(\n");
		rcmArray.push("  \"比率の差\",\n");
		rcmArray.push("  \"オッズ比\")\n");
		rcmArray.push("colnames(tr3) <- c(\n");
		rcmArray.push("  \" 点推定\",\n");
		rcmArray.push("  paste(\" \",\n");
		rcmArray.push("    paste(shinrai*100,\"％信頼下限値\",sep=\"\"),\n");
		rcmArray.push("    sep=\"\"),\n");
		rcmArray.push("  \" 上限値\")\n");
		rcmArray.push("\n");
		rcmArray.push("# パワアナ\n");
		rcmArray.push("kNN <- NA\n");
		rcmArray.push("kNN <- c(\n");
		rcmArray.push("  pwr.chisq.test(\n");
		rcmArray.push("  w=ES.w2(hyo/sum(hyo)),\n");
		rcmArray.push("  N=NULL,\n");
		rcmArray.push("  df=1,\n");
		rcmArray.push("  si=0.05, po=0.80)$N,\n");
		rcmArray.push("  kNN )\n");
		rcmArray.push("\n");
		rcmArray.push("kSi <- NA\n");
		rcmArray.push("kSi <- c(\n");
		rcmArray.push("  pwr.2p2n.test( al=H1,\n");
		rcmArray.push("  h=es, n1=n1, n2=n2,\n");
		rcmArray.push("  si=NULL, po=0.80)$si,\n");
		rcmArray.push("  kSi )\n");
		rcmArray.push("\n");
		rcmArray.push("tr4 <- c()\n");
		rcmArray.push("tr4 <- data.frame( matrix(c(\n");
		rcmArray.push("  round(es,  4),\n");
		rcmArray.push("  round(kSi[1], 4),\n");
		rcmArray.push("       0.80,\n");
		rcmArray.push("      n1+n2,\n");
		rcmArray.push("\n");
		rcmArray.push("  round(es,  4),\n");
		rcmArray.push("      0.05,\n");
		rcmArray.push("      0.80,\n");
		rcmArray.push("  ceiling(kNN[1])\n");
		rcmArray.push("  ), nr=2, by=1) )\n");
		rcmArray.push("rownames(tr4) <- c(\n");
		rcmArray.push("  \" α の計算\",\n");
		rcmArray.push("  \" Ｎ の計算\" )\n");
		rcmArray.push("colnames(tr4) <- c(\n");
		rcmArray.push("  \"効果量ｈ\",\n");
		rcmArray.push("  \"   α\",\n");
		rcmArray.push("  \" 1-β\",\n");
		rcmArray.push("  \"  Ｎ\" )\n");

		if (raA >= raC) {
			rcmArray.push("\n");
			rcmArray.push("options(digits=4)\n");
			rcmArray.push("options(scipen=5)\n");
			rcmArray.push("#######################################\n");
			rcmArray.push("# 直接確率計算２×２：                #\n");
			rcmArray.push("#  ２群×２値の分析                  #\n");
			rcmArray.push("# ・Ｆisher の正確検定（片側 greater）#\n");
			rcmArray.push("#######################################\n");
			rcmArray.push("tx1 # 度数集計表\n");
			rcmArray.push("\n");
			rcmArray.push("tg1 # フィッシャーの正確検定\n");
			rcmArray.push("\n");
			rcmArray.push("tg3 # 点推定と信頼区間推定\n");
			rcmArray.push("\n");
			rcmArray.push("tg4 # パワーアナリシス（対立仮説：greater）\n");
			rcmArray.push("# ■ NULL, NA が表示されたら計算不能■\n");
			rcmArray.push("# n1,n2 はそれぞれ群１，群２の度数を示す\n");
		} else if (raA < raC) {
			rcmArray.push("\n");
			rcmArray.push("options(digits=4)\n");
			rcmArray.push("options(scipen=5)\n");
			rcmArray.push("####################################\n");
			rcmArray.push("# 直接確率計算２×２：             #\n");
			rcmArray.push("#  ２群×２値の分析               #\n");
			rcmArray.push("# ・Ｆisher の正確検定（片側 less）#\n");
			rcmArray.push("####################################\n");
			rcmArray.push("tx1 # 度数集計表\n");
			rcmArray.push("\n");
			rcmArray.push("tl1 # フィッシャーの正確検定\n");
			rcmArray.push("\n");
			rcmArray.push("tl3 # 点推定と信頼区間推定\n");
			rcmArray.push("\n");
			rcmArray.push("tl4 # パワーアナリシス（対立仮説：less）\n");
			rcmArray.push("# ■ NULL, NA が表示されたら計算不能■\n");
			rcmArray.push("# n1,n2 はそれぞれ群１，群２の度数を示す\n");
		}

		rcmArray.push("\n");
		rcmArray.push("options(digits=4)\n");
		rcmArray.push("options(scipen=5)\n");
		rcmArray.push("################################\n");
		rcmArray.push("# 直接確率計算２×２：         #\n");
		rcmArray.push("#  ２群×２値の分析           #\n");
		rcmArray.push("# ・Ｆisher の正確検定（両側） #\n");
		rcmArray.push("# ・独立比率の差の検定（両側） #\n");
		rcmArray.push("################################\n");
		rcmArray.push("tx1 # 度数集計表\n");
		rcmArray.push("\n");
		rcmArray.push("tr1 # フィッシャーの正確検定\n");
		rcmArray.push("\n");
		rcmArray.push("tr2 # 独立比率の差の検定（連続性修正）\n");
		rcmArray.push("# p<α なら「値１の比率の差≠０」\n");
		rcmArray.push("#   〃  「値１のオッズ比≠１」\n");
		rcmArray.push("# 効果量ｈの評価：大=0.8, 中=0.5, 小=0.2\n");
		rcmArray.push("\n");
		rcmArray.push("tr3 # 点推定と信頼区間推定\n");
		rcmArray.push("\n");
		rcmArray.push("tr4 # パワーアナリシス（対立仮説：両側）\n");
		rcmArray.push("# ■ NULL, NA が表示されたら計算不能■\n");
		rcmArray.push("# Ｎは合計度数（total sample size）を示す\n");

		rcmArray.push("\n");
		rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/");
		rcmArray.push("\n");

		if (document.getElementById("RltAdd").checked) {
			document.getElementById("RcmArea").value += "\n\n" + rcmArray.join("");
		} else {
			document.getElementById("RcmArea").value = rcmArray.join("");
		}
		rcmArray = null;
	}());	//Ｒプログラムここまで

	//グラフ描画
	(function () {
		if (document.getElementById("RltAdd").checked === false) {
			chartClear();
		}

		var parent = document.getElementById("chart");
		var childElementCount = parent.childElementCount;

		var i;
		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg" + childElementCount;
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var data = [];
		for (i = 0; i < 2; i++) {
			data[i] = [];
		}
		data[0][0] = (raA * 100).toFixed(4);
		data[0][1] = (raC * 100).toFixed(4);
		data[1][0] = (raB * 100).toFixed(4);
		data[1][1] = (raD * 100).toFixed(4);

		var datasetKey = [];
		for (i = 0; i < 2; i++) {
			datasetKey[i] = [];
		}
		for (i = 0; i < 2; i++) {
			datasetKey[i].label = '値' + (i + 1);
			datasetKey[i].data = data[i];
			datasetKey[i].backgroundColor = 'rgba(' + 128 * i + ',' + 128 * i + ',' + 128 * i + ')';
			datasetKey[i].borderColor = 'rgba(' + 128 * i + ',' + 128 * i + ',' + 128 * i + ')';
			datasetKey[i].borderWidth = 1;
		}

		var datasetData = [];
		// var dataset = [datas[0], datas[1]];
		for (i = 0; i < 2; i++) {
			datasetData[i] = datasetKey[i];
		}
		var myChart = new Chart(ctx, {
			type: 'horizontalBar',
			data: {
				labels: ['群１', '群２'],
				datasets: datasetData
			},
			options: {
				title: {
					display: true,
					text: '値１（黒）と値２（灰白）の比率',
					position: 'top',
					fontSize: 12,
					fontColor: '#000000'
				},
				scales: {
					xAxes: [{
						stacked: true,
						ticks: {
							beginAtZero: true,
							min: 0,
							max: 100
						}
					}],
					yAxes: [{
						stacked: true
					}]
				},
				legend: {
					position: 'bottom'
				}
			}
		});
	}());

	document.getElementById("RltArea").focus();
}
function sum() {
	var i = 1;
	var iCount = 2;
	var jCount = 2;
	var elmCount = iCount * jCount;

	var wSum = 0;

	for (i = 1; i < elmCount + 1; i++) {
		if (isNaN(parseInt(document.getElementById("cell_" + i).value)) === false) {
			wSum += parseInt(document.getElementById("cell_" + i).value);
		}
	}
	document.getElementById("cell_sum").value = wSum;
}
function saveData_2x2() {
	var i, j;

	var strArray = [];

	var DD1 = parseInt(document.getElementById("cell_1").value);
	var DD2 = parseInt(document.getElementById("cell_2").value);
	var DD3 = parseInt(document.getElementById("cell_3").value);
	var DD4 = parseInt(document.getElementById("cell_4").value);

	strArray.push(DD1 + "\t" + DD2 + "\n");
	strArray.push(DD3 + "\t" + DD4 + "\n");

	var Stream = strArray.join("");
	var fineName = "2x2_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}