/**
 * 分散分析
 * sA(１要因参加者内計画)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeSaSetting();
	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
	var i = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value);

	var elmCount = NN * LA;

	var result = confirm("データを消去します");
	if (result === true) {
		document.getElementById("factorA_name").value = "A";
		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	document.getElementById("cell_1").focus();
}
// 入力チェック
function checkCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value, 10);
	var elmCount = NN * LA;

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === '') {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value === '') {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_sA();
		} else {
			alert("すべての数値が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_sA() {
	var i = 0;
	var j = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var AA = document.getElementById("factorA_name").value;
	var LA = parseInt(document.getElementById("factorA_number").value, 10);

	AA = AA.replace(/\s/g, "_"); //半角スペースを＿に変換する
	if (AA === '') AA = "A";

	var NA = NN;

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NN);
	}

	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
		}
	}

	var M = [];
	var mm;
	var SD = [];
	var sd;

	var MC$;
	var EQ$;

	var strArray = [];
	var bar = "------------------------------------------------\n";

	//平均・標準偏差
	strArray.push("[ sA-Type Design ]\n\n");
	strArray.push(" == Mean & S.D. ( SD=sqrt(Vtotal/N) ) ==\n\n");
	strArray.push("  A= " + AA + "\n");
	strArray.push(bar);
	strArray.push("A\tN\t\tMean\t\tS.D.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		for (j = 0; j < NN; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);
		}

		M[i] = S / NN;
		mm = using(M[i], 5, 4);
		SD[i] = Math.sqrt(SS / NN - Math.pow(M[i], 2));
		sd = using(SD[i], 5, 4);
		strArray.push((i + 1) + "\t" + NN + "\t" + mm + "\t" + sd + "\t\n");
	}

	//分散分析
	// S.V    SS    df    MS    F
	// -----------------------------------
	// subj   SSUB  DS    MS
	//  A      A    DA    MA    FA    FA$
	// sxA     E    DE    ME
	// -----------------------------------
	// Total   T    DSAE

	// S.V    SS    df    MS    F     p
	// -----------------------------------
	// subj   SSs   DFs   MSs
	//  A     SSa   DFa   MSa   Fa    Pa
	// sxA    SSe   DFe   MSe
	// -----------------------------------
	// Total  SSt   DFt

	strArray.push(bar);
	strArray.push("\n == Analysis of Variance ==\n\n");
	strArray.push(" S.V        SS        df        MS        F\n");

	S = 0;
	for (i = 0; i < LA; i++) {
		S = S + M[i];
	}
	var DH = S / LA;
	var A = 0;
	var MD;
	for (i = 0; i < LA; i++) {
		MD = Math.pow(M[i] - DH, 2);
		A = A + MD * NN;
	}
	var SSUB = 0;
	SS = 0;
	for (j = 0; j < NN; j++) {
		S = 0;
		for (i = 0; i < LA; i++) {
			S = S + xx[i][j];
		}
		SSUB = SSUB + Math.pow(S, 2);
		SS = SS + S;
	}
	SSUB = SSUB / LA - Math.pow(SS, 2) / LA / NN;
	var E = 0;
	S = 0;
	for (i = 0; i < LA; i++) {
		S = S + Math.pow(SD[i], 2) * NN;
	}
	E = S - SSUB;
	var T = A + SSUB + E;
	var DA = LA - 1;
	var MA = A / DA;
	var DS = NN - 1;
	var MS = SSUB / DS;
	var DE = DA * DS;
	var ME = E / DE;
	var FA = MA / ME;
	var DSAE = DS + DA + DE;

	var D1 = DA;
	var D2 = DE;
	var Fdata = FA;
	var FA$ = pValue_Match_fRatio(D1, D2, Fdata);

	// var ssub = using(SSUB,10,4);
	// var ds = using(DS,4,0);
	// var ms = using(MS,8,4);
	// var a = using(A,11,4);
	// var da = using(DA,4,0);
	// var ma = using(MA,8,4);
	// var fa = using(FA,3,2);
	// var e = using(E,9,4);
	// var de = using(DE,4,0);
	// var me = using(ME,8,4);
	// var t = using(T,9,4);
	// var dsae = using(DSAE,4,0);

	strArray.push(bar);
	strArray.push(" subj" + using(SSUB, 10, 4) + " " + using(DS, 4, 0) + " " + using(MS, 8, 4) + "\n");
	strArray.push(bar);
	strArray.push("  A" + using(A, 11, 4) + " " + using(DA, 4, 0) + " " + using(MA, 8, 4) + " " + using(FA, 3, 2) + " " + FA$ + "\n");
	strArray.push(" sxA " + using(E, 9, 4) + " " + using(DE, 4, 0) + " " + using(ME, 8, 4) + "\n");
	strArray.push(bar);
	strArray.push("Total" + using(T, 9, 4) + " " + using(DSAE, 4, 0));
	strArray.push("   +p<.10 *p<.05 **p<.01\n\n");

	// strArray.push(bar);
	// strArray.push(" subj"+ssub+" "+ds+" "+ms+"\n");
	// strArray.push(bar);
	// strArray.push("  A"+a+" "+da+" "+ma+" "+fa+" "+FA$+"\n");
	// strArray.push(" sxA "+e+" "+de+" "+me+"\n");
	// strArray.push(bar);
	// strArray.push("Total"+t+" "+dsae);
	// strArray.push("   +p<.10 *p<.05 **p<.01\n\n");

	//効果量
	var effectSizeF = Math.sqrt(DA / DE * FA);
	strArray.push("\n == EffectSize ==\n\n");
	strArray.push("\teffectsize f\n");
	strArray.push(bar);
	strArray.push("  A\t" + effectSizeF.toFixed(4) + "\n");
	strArray.push(bar);
	strArray.push("\t\tLarge=0.4 , Medium=0.25 , Small=0.1\n");

	//多重比較
	var checkedLsd = false;
	var checkedHsd = false;
	var checkedBonf = false;
	var checkedHolm = false;

	checkedLsd = document.getElementById("LSD").checked;
	checkedHsd = document.getElementById("HSD").checked;
	checkedBonf = document.getElementById("BONF").checked;
	checkedHolm = document.getElementById("HOLM").checked;

	//多重比較 LSD
	if (checkedLsd) {
		if (FA$ != "ns") {
			if (LA > 2) {
				// var T2 = 0;
				var T2 = tvalue(D2);

				var LSD = T2 * Math.sqrt(2 * ME / NN);
				var lsd = using(LSD, 8, 4);

				strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
				strArray.push(" (MSe=" + using(ME, 8, 4) + ", * p<.05)\n");
				strArray.push(" (LSD=" + lsd + ")\n");
				strArray.push(bar);

				for (i = 0; i < LA - 1; i++) {
					for (ii = i + 1; ii < LA; ii++) {
						if (Math.abs(M[i] - M[ii]) > LSD) {
							MC$ = " *  ";
						} else {
							MC$ = "n.s.";
							EQ$ = "=";
						}
						if (MC$ == " *  ") {
							if (M[i] > M[ii]) {
								EQ$ = ">";
							} else {
								EQ$ = "<";
							}
						}
						strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "\n");
					}
				}
				strArray.push(bar);
			}
		}
	}

	//多重比較 Bonferroni
	if (checkedBonf) {
		if (FA$ != "ns") {
			if (LA > 2) {
				var kumi = 0;
				kumi = kumiawase(LA, 2);
				var TB = 0;
				TB = bonf_tValue(kumi, DE);
				var alpha_d = 0;
				alpha_d = using(0.05 / kumi, 2, 4);

				var BONF = TB * Math.sqrt(2 * ME / NA);
				var bonf = using(BONF, 7, 4);

				strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
				strArray.push(" (MSe=" + using(ME, 8, 4) + ", * p<.05 , alpha'=" + alpha_d + ")\n");
				strArray.push(" (BONF=" + bonf + ")\n");
				strArray.push(bar);

				for (i = 0; i < LA - 1; i++) {
					for (ii = i + 1; ii < LA; ii++) {
						if (Math.abs(M[i] - M[ii]) > BONF) {
							MC$ = " *  ";
						} else {
							MC$ = "n.s.";
							EQ$ = "=";
						}
						if (MC$ == " *  ") {
							if (M[i] > M[ii]) {
								EQ$ = ">";
							} else {
								EQ$ = "<";
							}
						}
						strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "\n");
					}
				}
				strArray.push(bar);
			}
		}
	}

	//多重比較 Holm
	if (checkedHolm) {
		if (FA$ != "ns") {
			if (LA > 2) {
				var kumi = 0;
				kumi = kumiawase(LA, 2);

				var TL = [];
				var TLN = []; //順番を保存
				var HMC$ = [];
				var alpha_d = [];

				var tlcount = 0;
				for (i = 0; i < LA - 1; i++) {
					for (ii = i + 1; ii < LA; ii++) {
						TL[tlcount] = Math.abs(M[i] - M[ii]) / Math.sqrt(2 * ME / NA);
						TLN[tlcount] = tlcount;
						tlcount++;
					}
				}

				//TL値の小さい順に並び替え（同時にTLN値も）
				var temp;
				var temp2;
				for (i = 0; i < kumi; i++) {
					for (j = kumi - 1; j > 0; j--) {
						if (TL[j] < TL[j - 1]) {
							temp = TL[j];
							temp2 = TLN[j];
							TL[j] = TL[j - 1];
							TLN[j] = TLN[j - 1];
							TL[j - 1] = temp;
							TLN[j - 1] = temp2;
						}
					}
				}

				//TL値を計算
				var kflag = 1; //１のとき棄却する 0だと検定終了
				for (i = kumi; i > 0; i--) {
					if (kflag) {
						if (TL[i - 1] >= bonf_tValue(i, DE)) {
							HMC$[i - 1] = " *  ";
						} else {
							HMC$[i - 1] = "n.s.";
							kflag = 0; //検定終了 以降はすべて保留
						}
					} else {
						HMC$[i - 1] = "n.s.";
					}
					alpha_d[i - 1] = using(0.05 / i, 2, 4);
				}

				//TLN値の小さい順に並び替え
				var temp3;
				var temp4;
				for (i = 0; i < kumi; i++) {
					for (j = kumi - 1; j > 0; j--) {
						if (TLN[j] < TLN[j - 1]) {
							temp = TL[j];
							temp2 = TLN[j];
							temp3 = HMC$[j];
							temp4 = alpha_d[j];
							TL[j] = TL[j - 1];
							TLN[j] = TLN[j - 1];
							HMC$[j] = HMC$[j - 1];
							alpha_d[j] = alpha_d[j - 1];
							TL[j - 1] = temp;
							TLN[j - 1] = temp2;
							HMC$[j - 1] = temp3;
							alpha_d[j - 1] = temp4;
						}
					}
				}

				strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
				strArray.push(" (MSe=" + using(ME, 8, 4) + ", * p<.05)\n");
				strArray.push(bar);
				tlcount = 0;
				for (i = 0; i < LA - 1; i++) {
					for (ii = i + 1; ii < LA; ii++) {
						if (HMC$[tlcount] == " *  ") {
							if (M[i] > M[ii]) {
								EQ$ = ">";
							} else {
								EQ$ = "<";
							}
						} else {
							EQ$ = "=";
						}
						strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
						tlcount++;
					}
				}
				strArray.push(bar);
			}
		}
	}

	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//グラフの設定
	var gCheck = document.getElementById("RltArea").value;
	gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム
	(function () {
		var rcmArray = [];
		var spc = "          ";

		rcmArray.push("####### 分散分析ｓＡ(１要因参加者内) #######\n");
		rcmArray.push("\n");
		rcmArray.push("## js-STARの入力: sA\n");
		rcmArray.push("levA <- " + LA + "\n");
		rcmArray.push("n    <- c(");
		for (i = 0; i < LA; i++) {
			rcmArray.push(NN);
			if (i != LA - 1) {
				rcmArray.push(",");
			}
		}
		rcmArray.push(")\n");
		rcmArray.push("\n");

		rcmArray.push("data <- c(\n");
		for (j = 0; j < NN; j++) {
			for (i = 0; i < LA; i++) {
				rcmArray.push(" " + xx[i][j]);
				if ((j != NN - 1) || (i != LA - 1)) {
					rcmArray.push(",");
				}
			}
			rcmArray.push("\n");
		}
		rcmArray.push(")\n");
		rcmArray.push("## js-STARの入力おわり\n");

		rcmArray.push("\n");
		rcmArray.push("## スタック形式のデータセット\n");
		rcmArray.push("s  <- gl(mean(n), levA)\n");
		rcmArray.push("A  <- gl(levA, 1, n[1]*levA)\n");
		rcmArray.push("sA <- data.frame(s, A, data)\n");
		rcmArray.push("N  <- mean(n)\n");
		rcmArray.push("\n");
		rcmArray.push("## 基本統計量の計算\n");
		rcmArray.push("hk  <- tapply(sA$data, sA$A, mean)\n");
		rcmArray.push("sd  <- tapply(sA$data, sA$A, sd)\n");
		rcmArray.push("mi  <- tapply(sA$data, sA$A, min)\n");
		rcmArray.push("ma  <- tapply(sA$data, sA$A, max)\n");
		rcmArray.push("\n");
		rcmArray.push("tx1 <- matrix(round(c(\n");
		rcmArray.push("  n,\n");
		rcmArray.push("  hk,\n");
		rcmArray.push("  sd,\n");
		rcmArray.push("  mi,\n");
		rcmArray.push("  ma\n");
		rcmArray.push("  ), 4), nc=5 )\n");
		rcmArray.push("colnames(tx1) <- c(\n");
		rcmArray.push("  \"   Ｎ\",\n");
		rcmArray.push("  \"     Mean\",\n");
		rcmArray.push("  \"       SD\",\n");
		rcmArray.push("  \"   Min\",\n");
		rcmArray.push("  \"   Max\" )\n");
		rcmArray.push("rownames(tx1) <- c(\n");
		rcmArray.push("  paste(\"A.\", 1:levA, sep=\"\")\n");
		rcmArray.push("  )\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("## 作図：プロット＆ラインズ\n");
		rcmArray.push("suij <- 1:levA           # 水準番号\n");
		rcmArray.push("xjik <- c(1-.3, levA+.3) # ｘ軸の拡幅\n");
		rcmArray.push("bai=2                    # ｙ軸の拡幅倍率\n");
		rcmArray.push("yjik <- c(\n");
		rcmArray.push("  min(hk)-max(sd)*bai,\n");
		rcmArray.push("  max(hk)+max(sd)*bai)\n");
		rcmArray.push("\n");
		rcmArray.push("plot(suij, hk,                 # 描点指定\n");
		rcmArray.push("  bty=\"l\", xli=xjik, yli=yjik, # 枠の設定\n");
		rcmArray.push("  tck=0.03,                    # 目盛り突起\n");
		rcmArray.push("  las=1,                       # 目盛り正立\n");
		rcmArray.push("  xlab=c(\"水準番号\"),\n");
		rcmArray.push("  ylab=c(\"\"),\n");
		rcmArray.push("  xaxt=\"n\",\n");
		rcmArray.push("  main=c(\"標準偏差= 不偏分散の平方根\")\n");
		rcmArray.push("  )\n");
		rcmArray.push("axis(side=1,\n");
		rcmArray.push("     at=1:levA,\n");
		rcmArray.push("     tck=0.03,\n");
		rcmArray.push("     labels=c(");
		for (i = 0; i < LA; i++) {
			rcmArray.push("\"" + AA + (i + 1) + "\"");
			if (i != LA - 1) {
				rcmArray.push(",");
			}
		}
		rcmArray.push(")\n");
		rcmArray.push("     )\n");
		rcmArray.push("arrows(\n");
		rcmArray.push("  suij,hk, suij,hk+sd, # ＳＤ上向き\n");
		rcmArray.push("  ang=90, le=0.15 )    # 矢羽の角度と長さ\n");
		rcmArray.push("arrows(\n");
		rcmArray.push("  suij,hk, suij,hk-sd, # ＳＤ下向き\n");
		rcmArray.push("  ang=90, le=0.15 )\n");
		rcmArray.push("\n");
		rcmArray.push("lines (suij,hk, lwd=2,col=1) # 線幅,線色\n");
		rcmArray.push("points(suij,hk, pch=21,      # 描点21番\n");
		rcmArray.push("       cex=3, bg=1 )         # ４倍,黒色\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("## 分散分析\n");
		rcmArray.push("kx2 <- c()\n");
		rcmArray.push("kx2 <- anova(lm(data~s+A, sA))\n");
		rcmArray.push("tx2 <- c()\n");
		rcmArray.push("tx2 <- matrix(round( c(\n");
		rcmArray.push("  kx2$S,kx2$D,kx2$M,kx2$F,kx2$P\n");
		rcmArray.push("  ), 4), nr=3)\n");
		rcmArray.push("colnames(tx2) <- c(\n");
		rcmArray.push("  \"       SS\",\n");
		rcmArray.push("  \"  df\",\n");
		rcmArray.push("  \"       MS\",\n");
		rcmArray.push("  \"      Ｆ\",\n");
		rcmArray.push("  \"     ｐ\")\n");
		rcmArray.push("rownames(tx2) <- c(\n");
		rcmArray.push("  \" ｓ \",\n");
		rcmArray.push("  \"要因Ａ\",\n");
		rcmArray.push("  \"ｓ×Ａ\")\n");
		rcmArray.push("\n");
		rcmArray.push("kx3 <- c()\n");
		rcmArray.push("kx3 <- pairwise.t.test( # 多重比較\n");
		rcmArray.push("  sA$data, sA$A,\n");
		rcmArray.push("  p.ad=\"BH\", pair=1)    # 対応あり\n");
		rcmArray.push("tx3 <- c()\n");
		rcmArray.push("tx3 <- round(kx3$p.v, 4)\n");
		rcmArray.push("dimnames(tx3) <- list(\n");
		rcmArray.push("  c(paste(\"A.\", 2:levA,   sep=\"\")),\n");
		rcmArray.push("  c(paste(\"   A.\", 2:levA-1, sep=\"\")) )\n");
		rcmArray.push("\n");
		rcmArray.push("## パワーアナリシス\n");
		rcmArray.push("df1 <- kx2$D[2]\n");
		rcmArray.push("df2 <- kx2$D[3]\n");
		rcmArray.push("Fa  <- kx2$F[2]\n");
		rcmArray.push("es  <- sqrt(Fa*df1/df2) # ES.f\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("# 検出力\n");
		rcmArray.push("epsi <- 1  # 球面性ε=1\n");
		rcmArray.push("\n");
		rcmArray.push("dmat <- matrix(sA$data,nr=N,by=1)\n");
		rcmArray.push("fugo <- sign(cor(dmat))\n");
		rcmArray.push("vsum <- sum(cor(dmat)^2*fugo)-levA\n");
		rcmArray.push("corr <- sqrt(  # 平均相関\n");
		rcmArray.push("  abs(vsum)/(levA^2-levA)\n");
		rcmArray.push("  )*sign(vsum)\n");
		rcmArray.push("\n");
		rcmArray.push("corr <- abs(sum(cor(dmat))-levA)/(levA^2-levA) # 単純平均\n");
		rcmArray.push("\n");
		rcmArray.push("NCP <-  # 非心度\n");
		rcmArray.push("  es^2*levA*N*(1/(1-corr))*epsi\n");
		rcmArray.push("crF <- qf(0.05,\n");
		rcmArray.push("  df1=df1,df2=df2,low=0)\n");
		rcmArray.push("pow <- 1-pf(crF,\n");
		rcmArray.push("  df1=df1,df2=df2,ncp=NCP)\n");
		rcmArray.push("\n");
		rcmArray.push("ncp0 <- es^2*levA*N\n");
		rcmArray.push("pow0 <- 1-pf(\n");
		rcmArray.push("  crF,df1=df1,df2=df2,ncp=ncp0)\n");
		rcmArray.push("\n");
		rcmArray.push("ncpSPSS <- es^2*df2\n");
		rcmArray.push("powSPSS <- 1-pf(\n");
		rcmArray.push("  crF,df1=df1,df2=df2,ncp=ncpSPSS)\n");
		rcmArray.push("\n");
		rcmArray.push("# α\n");
		rcmArray.push("crF  <- qf(0.20,df1=df1,df2=df2,ncp=NCP)\n");
		rcmArray.push("alph <- pf(crF,df1=df1,df2=df2,low=0)\n");
		rcmArray.push("\n");
		rcmArray.push("# Ｎのシミュレーション\n");
		rcmArray.push("DFv <- NA\n");
		rcmArray.push("kos <- 0   # 出力回数\n");
		rcmArray.push("if (pow<0.80)\n");
		rcmArray.push("  for(i in 1:100000){\n");
		rcmArray.push("    if (kos>1) i=99999\n");
		rcmArray.push("    else {\n");
		rcmArray.push("      DF2  <- df2+(i*0.01)\n");
		rcmArray.push("      DF2  <- min(DF2, 1000)\n");
		rcmArray.push("      ncp <- es^2*levA*(DF2/df1+1)*(1/(1-corr))*epsi\n");
		rcmArray.push("      crF  <- qf(0.95,df1=df1,df2=DF2)\n");
		rcmArray.push("      beta <- pf(crF, df1=df1,df2=DF2,ncp=ncp)\n");
		rcmArray.push("\n");
		rcmArray.push("      if (beta<0.20) kos=kos+1\n");
		rcmArray.push("      if (kos==1)    DFv <- c(DF2, DFv) }\n");
		rcmArray.push("  }\n");
		rcmArray.push("if (pow>0.80)\n");
		rcmArray.push("  for(i in 1:100000){\n");
		rcmArray.push("    if (kos>1) i=99999\n");
		rcmArray.push("    else {\n");
		rcmArray.push("      DF2  <- df2-(i*0.01)\n");
		rcmArray.push("      DF2  <- max(DF2, 2)\n");
		rcmArray.push("      ncp <- es^2*levA*(DF2/df1+1)*(1/(1-corr))*epsi\n");
		rcmArray.push("      crF  <- qf(0.95,df1=df1,df2=DF2)\n");
		rcmArray.push("      beta <- pf(crF, df1=df1,df2=DF2,ncp=ncp)\n");
		rcmArray.push("\n");
		rcmArray.push("      if (beta>0.20) kos=kos+1\n");
		rcmArray.push("      if (kos==1)    DFv <- c(DF2, DFv) }\n");
		rcmArray.push("  }\n");
		rcmArray.push("\n");
		rcmArray.push("tx4 <- c()\n");
		rcmArray.push("tx4 <- matrix(round(c(\n");
		rcmArray.push("  Fa, es, pow, pow0, powSPSS\n");
		rcmArray.push("  ), 4), nr=1 )\n");
		rcmArray.push("colnames(tx4) <- c(\n");
		rcmArray.push("  \"Ｆ値\",\n");
		rcmArray.push("  \" 効果量ｆ\",\n");
		rcmArray.push("  \" 検出力1\",\n");
		rcmArray.push("  \" 検出力0\",\n");
		rcmArray.push("  \" 検出力2\" )\n");
		rcmArray.push("rownames(tx4) <- c(\n");
		rcmArray.push("  \"要因Ａ\" )\n");
		rcmArray.push("\n");
		rcmArray.push("tz8 <- c()\n");
		rcmArray.push("tz8 <- matrix(round(c(\n");
		rcmArray.push("  es, 0.80, alph, df1, df2,\n");
		rcmArray.push("  es, 0.80, 0.05, df1, DFv[1]\n");
		rcmArray.push("  ), 4), nr=2, by=1 )\n");
		rcmArray.push("colnames(tz8) <- c(\n");
		rcmArray.push("  \"効果量ｆ\",\n");
		rcmArray.push("  \" 検出力\",\n");
		rcmArray.push("  \"     α\",\n");
		rcmArray.push("  \"df1\",\n");
		rcmArray.push("  \"    df2\")\n");
		rcmArray.push("rownames(tz8) <- c(\n");
		rcmArray.push("  \" α の計算\",\n");
		rcmArray.push("  \" Ｎ の計算\")\n");
		rcmArray.push("\n");
		rcmArray.push("tz9 <- c()\n");
		rcmArray.push("tz9 <- matrix(round(c(\n");
		rcmArray.push("   ceiling(DFv[1]/df1+1),\n");
		rcmArray.push("   N,\n");
		rcmArray.push("   corr\n");
		rcmArray.push("   ), 4), nr=1)\n");
		rcmArray.push("rownames(tz9) <- c(\"Ｎ=df2/df1+1\")\n");
		rcmArray.push("colnames(tz9) <- c(\n");
		rcmArray.push("  \"次回総数\",\n");
		rcmArray.push("  \"  今回のＮ\",\n");
		rcmArray.push("  \"  水準間相関\" )\n");
		rcmArray.push("\n");
		rcmArray.push("# Mauchly.test\n");
		rcmArray.push("kx5 <- c()\n");
		rcmArray.push("kx5 <- mauchly.test(lm(dmat~1), X=~1)\n");
		rcmArray.push("tx5 <- c()\n");
		rcmArray.push("tx5 <- matrix(round(c(\n");
		rcmArray.push("  kx5$stat,\n");
		rcmArray.push("  kx5$p.val,\n");
		rcmArray.push("  1/(levA-1)\n");
		rcmArray.push("  ), 4), nr=1 )\n");
		rcmArray.push("rownames(tx5) <- c(\"要因Ａ\")\n");
		rcmArray.push("colnames(tx5) <- c(\n");
		rcmArray.push("  \"Mauchly's W\",\n");
		rcmArray.push("  \"    ｐ値\",\n");
		rcmArray.push("  \"  下限ε\" )\n");
		rcmArray.push("\n");
		rcmArray.push("kx6 <- c()\n");
		rcmArray.push("kx6 <- anova(lm(dmat~1), X=~1,\n");
		rcmArray.push("  test=\"Spherical\" )\n");
		rcmArray.push("tx6 <- c()\n");
		rcmArray.push("tx6 <- matrix(round(c(\n");
		rcmArray.push("  kx6$F[1],\n");
		rcmArray.push("  kx6$Pr[1],\n");
		rcmArray.push("  kx6$G[1],\n");
		rcmArray.push("  kx6$H[1]\n");
		rcmArray.push("  ), 4), nr=1)\n");
		rcmArray.push("colnames(tx6) <- c(\n");
		rcmArray.push("  \"   Ｆ値\",\n");
		rcmArray.push("  \"   ｐ値\",\n");
		rcmArray.push("  \"  G-G調整値\",\n");
		rcmArray.push("  \" H-F調整値\" )\n");
		rcmArray.push("rownames(tx6) <- c(\n");
		rcmArray.push("  \"要因Ａ\" )\n");
		rcmArray.push("\n");
		rcmArray.push("options(digits=5)\n");
		rcmArray.push("options(scipen=5)\n");
		rcmArray.push("###########################\n");
		rcmArray.push("#  分散分析 sＡ-design：  #\n");
		rcmArray.push("#  １要因 参加者内計画  #\n");
		rcmArray.push("###########################\n");
		rcmArray.push("tx1 # 基本統計量（SD=不偏分散の平方根）\n");
		rcmArray.push("\n");
		rcmArray.push("tx2 # 分散分析表\n");
		rcmArray.push("\n");
		rcmArray.push("tx4 # 効果量ｆと検出力(1-β)\n");
		rcmArray.push("    # Part.η2(偏イータ２乗)= f^2/(f^2+1)\n");
		rcmArray.push("    # 検出力1 は非心度推定= f^2*DataSize, r=r\n");
		rcmArray.push("    # 検出力0 は非心度推定= f^2*DataSize, r=0\n");
		rcmArray.push("    # 検出力2 は非心度推定= f^2*DFsxa\n");
		rcmArray.push("\n");
		rcmArray.push("tx3 # 多重比較（参加者内ｔ検定）\n");
		rcmArray.push("# 数値は調整後のｐ値（両側確率）\n");
		rcmArray.push("# ｐ値の調整は Benjamini & Hochberg(1995) による\n");
		rcmArray.push("\n");
		rcmArray.push("tz8 # パワーアナリシス\n");
		rcmArray.push("    # ■ NA が出力されたら計算不能\n");
		rcmArray.push("tz9 # Ｎ(total sample size)の計算\n");
		rcmArray.push("\n");
		rcmArray.push("tx5 # 球面性の検定（水準=２なら不要）\n");
		rcmArray.push("    # p<α なら球面性不成立！\n");
		rcmArray.push("tx6 # 球面性不成立のときの自由度調整Ｆ検定\n");
		rcmArray.push("\n");
		rcmArray.push("# ○オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray.push("# windows();boxplot(data~A,d=sA,las=1) # 箱ひげ図\n");
		rcmArray.push("# kx6[0,] # 自由度調整係数ε(epsilon)\n");

		rcmArray.push("\n");
		rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/");
		rcmArray.push("\n");

		document.getElementById("RcmArea").value = rcmArray.join("");
		rcmArray = null;
	}());	//Ｒプログラムここまで

	//グラフ描画
	(function () {
		chartClear();

		var i;
		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg0";
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var data = [];
		for (i = 0; i < LA; i++) {
			data[i] = Math.round(M[i] * 10) / 10;
		}

		var max_y = M[0];
		var min_y = 0;
		for (i = 0; i < LA; i++) {
			if (max_y < M[i]) max_y = Math.round(M[i] * 10) / 10;
			if (min_y > M[i]) min_y = Math.round(M[i] * 10) / 10;
		}
		var _myMax = gCheck.match(/max:\d+/);
		if (_myMax !== null) {
			var myMax = _myMax[0].match(/\d+/);
			max_y = parseFloat(myMax, 10);
		}
		var _myMin = gCheck.match(/min:\d+/);
		if (_myMin !== null) {
			var myMin = _myMin[0].match(/\d+/);
			min_y = parseFloat(myMin, 10);
		}

		//カラーユニバーサルデザイン推奨配色セット制作委員会
		//https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
		var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

		var datasetKey = [];
		for (i = 0; i < 2; i++) {
			datasetKey[i] = [];
		}

		// 複合グラフを作成する
		datasetKey[0].label = ''; //ラベルを空白にする

		var graphType = document.getElementById("graphSelect").value;

		var start;
		var end;

		// 折れ線グラフ
		if (graphType === 'line') {
			start = 0;
			end = 2;
			datasetKey[1].label = 'A';
			datasetKey[1].data = data;
			datasetKey[1].backgroundColor = chartClrAry[0];
			datasetKey[1].borderColor = chartClrAry[0];
			datasetKey[1].pointBorderWidth = 3;
			datasetKey[1].borderWidth = 1;
			datasetKey[1].lineTension = 0;
			datasetKey[1].type = 'line';
		}

		// 棒グラフ
		if (graphType === 'bar') {
			end = 1;
			datasetKey[0].label = 'A';
			datasetKey[0].data = data;
			datasetKey[0].backgroundColor = chartClrAry[0];
			datasetKey[0].borderColor = chartClrAry[0];
			datasetKey[0].pointBorderWidth = 3;
			datasetKey[0].borderWidth = 1;
			datasetKey[0].lineTension = 0;
			datasetKey[0].type = 'bar';
		}

		var labelData = [];
		for (i = 0; i < LA; i++) {
			labelData.push('A' + (i + 1));
		}

		var datasetData = [];
		for (i = 0; i < end; i++) {
			datasetData[i] = datasetKey[i];
		}

		var myChart = new Chart(ctx, {
			type: 'bar', //最初に棒グラフを指定
			data: {
				labels: labelData,
				datasets: datasetData
			},
			options: {
				scales: {
					xAxes: [{
						maxBarThickness: 30,
						ticks: {
						}
					}],
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
					display: true,
					labels: { //空白ラベルだったら表示しない
						filter: function (items, chart) {
							return items.text != '';
						},
					}
				},
				title: {
					display: true,
					text: 'Mean'
				}
			}
		});

		//箱ひげ図
		var addData = [];
		var myData = [];

		var arrayCol = [];
		for (i = 0; i < LA; i++) {
			arrayCol = [];
			for (j = 0; j < NN; j++) {
				arrayCol.push(xx[i][j]);
			}
			myData.push(arrayCol);
		}

		chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg1";
		ctx = document.getElementById("chart").appendChild(chartImg);

		var boxplotData = {
			labels: labelData,
			datasets: [{
				label: 'A',
				backgroundColor: chartClrAry[0] + '33',
				borderColor: chartClrAry[0],
				borderWidth: 1,
				padding: 10,
				outlierRadius: 3,
				itemRadius: 3,
				outlierColor: '#999999',
				data: myData
			}]
		};

		var myChart2 = new Chart(ctx, {
			type: 'boxplot',
			data: boxplotData,
			options: {
				responsive: true,
				scales: {
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
				},
				title: {
					display: true,
					text: 'Boxplot'
				}
			}
		});
	}());	//グラフ描画ここまで

	document.getElementById("RltArea").focus();
}
/**
 * [changeSaSetting id="sa_setting"の書き換え]
 *
 * 要因Aの水準数セレクトのid subjNum
 * 要因Aの名前 1行テキストボックスのid factorA_name
 * 要因Aの水準数1行テキストボックスのid factorA_number
 *
 */
function changeSaSetting() {
	var h = 3;
	var htmArray = [];

	// freqdata2を使うか要検討 todo
	// htmArray.push("<div class=\"freqdata2\">");
	htmArray.push("<div class=\"tateyoko\">");
	htmArray.push("<table border=\"0\" class=\"codetb\">");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">参加者数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" maxlength=\"10\"  min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\" oninput=\"changeSaTable();\">");
	} else {
		htmArray.push("<select id=\"subjNum\" name=\"j\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');changeSaTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 3; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">要因名：</td>");
	htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text6\" id=\"factorA_name\" size=\"20\" maxlength=\"20\" name=\"s1\" value=\"A\" onfocus=\"onBgColor(this);cellClearButton(this,'cellClrBtn1');\" onblur=\"offBgColor(this)\" onKeyUp=\"cellClearButton(this,'cellClrBtn1');\"><span id=\"cellClrBtn1\" class=\"cellClrBtnOn\" onclick=\"cellClr('factorA_name','cellClrBtn1');\" >×</span></td>");
	htmArray.push("</tr>");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">水準数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"factorA_number\" size=\"10\" maxlength=\"10\"  min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\" oninput=\"changeSaTable();\">");
	} else {
		htmArray.push("<select id=\"factorA_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'水準数');changeSaTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");

	document.getElementById("sa_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeSaTable();
}
function changeSaTable() {
	var i = 0;
	var j = 0;
	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value);

	var cellId = 1;
	var cellCount = NN * LA;

	var htmArray = [];

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		htmArray.push("水準" + (i + 1));
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	for (j = 0; j < NN; j++) {
		htmArray.push("<tr>");
		if (j === 0) {
			htmArray.push("<td class=\"hyou_midashi_3d_top\">");
		} else {
			htmArray.push("<td class=\"hyou_midashi_3d\">");
		}
		htmArray.push(j + 1);
		htmArray.push("</td>");
		for (i = 0; i < LA; i++) {
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
			htmArray.push("</td>");
			cellId++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");

	document.getElementById("sa_table").innerHTML = htmArray.join("");
	htmArray = null;
}
function saveData_sA() {
	var i, j;

	var strArray = [];

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var AA = document.getElementById("factorA_name").value;
	var LA = parseInt(document.getElementById("factorA_number").value, 10);

	//#0
	strArray.push("sA" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(NN + "\n");
	//#2
	strArray.push("#" + "\n");
	strArray.push(AA + "\n");
	//#3
	strArray.push("#" + "\n");
	strArray.push(LA + "\n");
	//#4
	strArray.push("#" + "\n");
	var x;
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			x = document.getElementById("cell_" + cellId).value;
			if (i !== LA - 1) {
				strArray.push(x + "\t");
			} else {
				strArray.push(x);
			}
			cellId++;
		}
		if (j !== NN - 1) {
			strArray.push("\n");
		}
	}

	var Stream = strArray.join("");
	var fineName = "sA_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_sA() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "sA") {
		var NN = crDel(dd[1]);
		var AA = crDel(dd[2]);
		var LA = crDel(dd[3]);

		document.getElementById("subjNum").value = parseInt(NN, 10);
		document.getElementById("factorA_name").value = AA;
		document.getElementById("factorA_number").value = parseInt(LA, 10);
		changeSaTable();
		document.getElementById("CandPArea").value = delTopCR(dd[4]);
	}
}
