window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();

};
//canvasサイズ
var cw = 550; //幅
var ch = 320; //高さ

var a = 28; //座標の幅
// 原点の位置
var ox = (cw - a * 10) / 2;
var oy = a * 10 + (ch - a * 10) / 2;

var PN = 2; //群（点）の数

var images = []; //点の画像配列
for (i = 0; i < PN; i++) {
    images[i] = new Image();
    var rnd = Math.floor(Math.random() * (10000));
    var str = '?var=' + rnd;
    images[i].src = '../image/line.png' + str;
}
var w = 28; //点の幅
var h = 56; //点の高さ

//点の値
var x = [];
var y = [];

//分散分析のための設定
var AA = 'A';
var LA = 2;
var BB = 'B';
var LB = 2;

var NN = 14;

var div = Math.floor(a * 10 / NN);

var M = new Array(LA);
for (i = 0; i < LA; i++) {
    M[i] = new Array(LB);
}

var SD = new Array(LA);
for (i = 0; i < LA; i++) {
    SD[i] = new Array(LB);
}

function setData() {
    x = [ox + a * 5, ox + a * 5];
    y = [oy - a * 7, oy - a * 3];

    NN = parseInt(document.getElementById('A1B1_N').value);
}
function DrawAxis() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    ctx.clearRect(0, 0, canvas.width, canvas.height);

    ctx.lineWidth = 1;
    ctx.strokeStyle = 'rgb(128,128,128)';

    ctx.setLineDash([3, 3]);

    for (i = 1; i < 10; i++) {
        ctx.beginPath();
        ctx.moveTo(ox + a * i, oy);
        ctx.lineTo(ox + a * i, oy - a * 10);
        ctx.stroke();
    }

    ctx.strokeStyle = 'rgb(0,0,0)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox + a * 10, oy);
    ctx.stroke();
    ctx.closePath();
    ctx.beginPath();
    ctx.moveTo(ox, oy - a * 10);
    ctx.lineTo(ox + a * 10, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * 10, oy);
    ctx.lineTo(ox + a * 10, oy - a * 10);
    ctx.stroke();

    ctx.fillStyle = 'rgb(0,0,0)';
    ctx.font = "12px Arial";
    ctx.textAlign = "right";
    ctx.beginPath();
    for (i = 1; i < 12; i++) {
        ctx.fillText(((i - 1) / 10).toFixed(1), ox + a * (i - 1) + 4, oy + 20);
    }
    ctx.closePath();

    ctx.font = "14px Arial";
    ctx.beginPath();
    ctx.fillText("標本比率", ox - 10, oy - a * 7 + 7);
    ctx.closePath();
    ctx.beginPath();
    ctx.fillText("母比率", ox - 10, oy - a * 3 + 7);
    ctx.closePath();
}
function DrawLine() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    var KK1, HH1;
    for (var i in images) {
        if (i == 0) {
            KK1 = Math.floor((x[i] - ox) / div);
            HH1 = KK1 / NN;
            x[i] = a * 10 * HH1 + ox;
            if (x[i] > a * 10 + ox) x[i] = a * 10 + ox;
        }
        // 画像を描画した時の情報を記憶
        images[i].drawOffsetX = x[i];
        images[i].drawOffsetY = y[i];
        images[i].drawWidth = w;
        images[i].drawHeight = h;
        //帯グラフを描画
        ctx.lineWidth = 1;
        ctx.fillStyle = 'rgb(0,0,0)';
        ctx.beginPath();
        var rw = x[i] - ox;
        var rh = h;
        ctx.fillRect(ox, y[i] - h / 2, rw, rh);
        ctx.closePath();
        ctx.fillStyle = 'rgb(200,200,200)';
        ctx.beginPath();
        rw = ox + a * 10 - x[i];
        rh = h;
        ctx.fillRect(x[i], y[i] - h / 2, rw, rh);
        ctx.closePath();
    }
}
function DrawPoint() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');
    for (var i in images) {
        // 画像を描画した時の情報を記憶
        images[i].drawOffsetX = x[i];
        images[i].drawOffsetY = y[i];
        images[i].drawWidth = w;
        images[i].drawHeight = h;

        // 画像を描画
        ctx.drawImage(images[i], x[i] - w / 2, y[i] - h / 2, w, h);
    }
}
function setDiv() {
    NN = parseInt(document.getElementById('A1B1_N').value);
    div = Math.floor(a * 10 / NN);
}
function mainPuma() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');
    var dragTarget = null;
    var isDragging = false;

    setData();
    DrawAxis();
    DrawLine();

    images[PN - 1].addEventListener('load', function () {
        DrawPoint();
    }, false);

    // printData();
    s_calc_1x2();

    // ドラッグ開始
    var mouseDown = function (e) {
        // ドラッグ開始位置
        var posX = parseInt(e.clientX - canvas.getBoundingClientRect().left) + w / 2;
        var posY = parseInt(e.clientY - canvas.getBoundingClientRect().top) + h / 2;

        for (var i = images.length - 1; i >= 0; i--) {
            // 当たり判定（ドラッグした位置が画像の範囲内に収まっているか）
            if (posX >= images[i].drawOffsetX &&
                posX <= (images[i].drawOffsetX + images[i].drawWidth) &&
                posY >= images[i].drawOffsetY &&
                posY <= (images[i].drawOffsetY + images[i].drawHeight)
            ) {
                dragTarget = i;
                isDragging = true;
                break;
            }
        }
    };

    // ドラッグ終了
    var mouseUp = function (e) {
        isDragging = false;
    };

    // canvasの枠から外れた
    var mouseOut = function (e) {
        // canvas外にマウスカーソルが移動した場合に、ドラッグ終了としたい場合はコメントインする
        // mouseUp(e);
    };

    // ドラッグ中
    var mouseMove = function (e) {
        // ドラッグ終了位置
        var posX = parseInt(e.clientX - canvas.getBoundingClientRect().left) + w / 2;
        var posY = parseInt(e.clientY - canvas.getBoundingClientRect().top) + h / 2;


        if ((posX < ox + w / 2) || (posX > ox + a * 10 + w / 2) || (posY < oy - a * 10 + h / 2) || (posY > oy + h / 2)) {
            isDragging = false;
        }

        if (isDragging) {
            var mx = 0;
            var my = 0;
            for (var i in images) {
                if (i == dragTarget) {
                    mx = posX - images[i].drawWidth / 2;
                    my = images[i].drawOffsetY;

                    // if(dragTarget === 0){
                    //     // mx = Math.floor((mx-ox)/NN)*NN+ox;
                    //     // console.log(mx);
                    //     mx = (mx-ox)/div*+ox;
                    // }
                    if (dragTarget === 1) {
                        mx = Math.floor((mx - ox) / 7) * 7 + ox;
                    }
                    // ドラッグが終了した時の情報を記憶
                    images[i].drawOffsetX = mx;
                    images[i].drawOffsetY = my;
                } else {
                    mx = images[i].drawOffsetX;
                    my = images[i].drawOffsetY;
                }
                w = images[i].drawWidth;
                h = images[i].drawHeight;

                x[i] = mx;
                y[i] = my;
            }

            s_calc_1x2();
            DrawAxis();
            DrawPoint();
            DrawLine();
        }
    };

    // canvasにイベント登録
    canvas.addEventListener('mousedown', function (e) { mouseDown(e); }, false);
    canvas.addEventListener('mousemove', function (e) { mouseMove(e); }, false);
    canvas.addEventListener('mouseup', function (e) { mouseUp(e); }, false);
    canvas.addEventListener('mouseout', function (e) { mouseOut(e); }, false);

}
function s_calc_1x2() {
    var i = 0;
    var j = 0;
    var k = 0;
    var h = 0;
    // var DD1 = parseInt();
    // var DD2 = parseInt(NN-DD1);

    var KK1 = Math.floor((x[0] - ox) / div);
    // var KK1 = Math.floor((x[0]-ox)/(a*10/NN));

    if (KK1 > NN) KK1 = NN;
    var KK2 = parseInt(NN - KK1, 10);
    var sKK1 = KK1;
    var sKK2 = KK2;

    // var NN = KK1+KK2;

    var ratio2 = (x[1] - ox) / (a * 10);
    var BB1 = parseFloat(ratio2);
    var BB2 = parseFloat(1 - ratio2);
    var BB0 = BB1 + BB2;

    var PP = 0;  //片側確率

    BB1 = BB1 / BB0;
    BB2 = BB2 / BB0;

    var sBB1 = BB1;
    var sBB2 = BB2;

    var HH1 = KK1 / NN;
    if (HH1 > 1) HH1 = 1.0;
    var HH2 = 1.0 - HH1;

    var strArray = [];
    var rcmArray = [];

    // document.getElementById("hyouhonhiritu").innerHTML = HH1.toFixed(2)+":"+HH2.toFixed(2);
    // document.getElementById("bohiritu").innerHTML = BB1.toFixed(2)+":"+BB2.toFixed(2);

    strArray.push("[1x2](母比率不等)\n\n");
    strArray.push("---------------------------------------------\n");
    strArray.push("観測値\t\t" + using(KK1, 5, 0) + "\t" + using(KK2, 5, 0) + "\n");
    strArray.push("観測値比率\t(" + using(HH1, 1, 4) + ") (" + using(HH2, 1, 4) + ")\n");
    strArray.push("---------------------------------------------\n");
    strArray.push("母比率\t\t" + using(BB1, 1, 4) + "\t" + using(BB2, 1, 4) + "\n");
    strArray.push("---------------------------------------------\n\n");

    if (KK1 > KK2) {
        dummy = KK1;
        KK1 = KK2;
        KK2 = dummy;

        dummy = BB1;
        BB1 = BB2;
        BB2 = dummy;
    }

    var temp;
    var R;
    if (KK1 < NN * BB1) {
        for (R = 0; R < KK1 + 1; R++) {
            temp = LogCombination(NN, R);
            PP = PP + Math.exp(temp + R * Math.log(BB1) + (NN - R) * Math.log(BB2));
        }
    } else {
        for (R = KK1; R < NN + 1; R++) {
            temp = LogCombination(NN, R);
            PP = PP + Math.exp(temp + R * Math.log(BB1) + (NN - R) * Math.log(BB2));
        }
    }

    var ppStr = "";
    if (PP < 0.01) {
        ppStr = "   ** (p<.01)";
    } else if (PP < 0.05) {
        ppStr = "   *  (p<.05)";
    } else if (PP < 0.10) {
        ppStr = "   +  (.05<p<.10)";
    } else {
        ppStr = "   ns (.10<p)";
    }

    // strArray.push("p="+using(PP,1,4)+ppStr+" (片側確率)\n");
    strArray.push("p=" + PP.toFixed(4) + ppStr + " (片側確率)\n");

    //出力
    document.getElementById("1x2DataArea").value = strArray.join("");
    strArray = null;
}