window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();
};

//canvasサイズ
var cw = 550; //幅
var ch = 320; //高さ

var a = 28; //座標の幅
// 原点の位置
var ox = (cw - a * 10) / 2;
var oy = a * 10 + (ch - a * 10) / 2;

var PN = 15; //点の数
var PNmax = 100; //点の最大数
var NN = PN; //人数

var images = []; //点の画像配列
var _rnd = Math.floor(Math.random() * (10000));
for (i = 0; i < PNmax; i++) {
    images[i] = new Image();

    var str = '?var=' + _rnd;
    images[i].src = '../image/point_corr.png' + str;
}
var w = 14; //点の幅
var h = 14; //点の高さ

//点の値
var x = [];
var y = [];

var xx = new Array(NN);
for (i = 0; i < PNmax; i++) {
    xx[i] = new Array(NN);
}

var A = 1; //回帰直線の傾き
var B = 0; //回帰直線の切片

function setData() {
    // for (var i in images) {
    PN = document.getElementById('PN_number').value;
    for (var i = 0; i < PN; i++) {
        x[i] = Math.floor(Math.random() * (ox + a * 10 - ox + 1) + ox) - w / 2;
        y[i] = Math.floor(Math.random() * (oy - a * 10 - oy + 1) + oy) - h / 2;
    }
}
function DrawAxis() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    ctx.clearRect(0, 0, canvas.width, canvas.height);

    ctx.lineWidth = 1;
    ctx.strokeStyle = 'rgb(128,128,128)';

    ctx.setLineDash([3, 3]);
    ctx.beginPath();
    ctx.moveTo(ox + a * 2, oy);
    ctx.lineTo(ox + a * 2, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * 8, oy);
    ctx.lineTo(ox + a * 8, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * 10, oy);
    ctx.lineTo(ox + a * 10, oy - a * 10);
    ctx.stroke();

    for (i = 1; i < 11; i++) {
        ctx.beginPath();
        ctx.moveTo(ox + a * i, oy);
        ctx.lineTo(ox + a * i, oy - a * 10);
        ctx.stroke();
    }

    for (j = 1; j < 11; j++) {
        ctx.beginPath();
        ctx.moveTo(ox, oy - a * j);
        ctx.lineTo(ox + a * 10, oy - a * j);
        ctx.stroke();
    }

    ctx.strokeStyle = 'rgb(0,0,0)';
    ctx.fillStyle = 'rgb(0,0,0)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox + a * 10, oy);
    ctx.stroke();

    ctx.font = "16px Arial";
    ctx.textAlign = "right";
    ctx.fillText("0", ox - 5, oy + 20);
    ctx.fillText("100", ox + a * 10 + 30, oy + 20);
    ctx.fillText("100", ox - 5, oy - a * 10);
}
function DrawLine() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    //回帰直線を描画
    // if (document.getElementById('Regressionline').checked) {
    ctx.lineWidth = 3;
    ctx.strokeStyle = 'rgb(255,165,0)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(ox, oy - a / 10 * B);
    ctx.lineTo(ox + a * 10, oy - a / 10 * B - A * (a * 10));
    ctx.stroke();
    // }
}
function DrawPoint() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    // for (var i in images) {
    PN = document.getElementById('PN_number').value;
    for (var i = 0; i < PN; i++) {
        // 画像を描画した時の情報を記憶
        images[i].drawOffsetX = x[i];
        images[i].drawOffsetY = y[i];
        images[i].drawWidth = w;
        images[i].drawHeight = h;

        // 画像を描画
        ctx.drawImage(images[i], x[i], y[i], w, h);
    }
}
function DrawText(tx, ty) {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    if (document.getElementById('Regressionline').checked) {
        ctx.font = "12px Arial";
        ctx.textAlign = "right";
        var x = Math.floor((tx - ox) * 10 / a);
        ctx.fillText(x, tx, oy + 20);
        var y = Math.floor(A * x + B);
        ctx.fillText(y, ox - 10, oy - y * a / 10);

        ctx.lineWidth = 1;
        ctx.strokeStyle = 'rgb(255,165,0)';
        ctx.setLineDash([]);
        ctx.beginPath();
        ctx.moveTo(tx, oy);
        ctx.lineTo(tx, oy - y * a / 10);
        ctx.stroke();
        ctx.beginPath();
        ctx.moveTo(tx, oy - y * a / 10);
        ctx.lineTo(ox, oy - y * a / 10);
        ctx.stroke();
    }
}
function DrawY() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    PN = document.getElementById('PN_number').value;

    if (document.getElementById('Suportline').checked) {
        var S = 0;
        for (var i = 0; i < PN; i++) {
            ctx.beginPath();
            ctx.lineWidth = 1;
            ctx.strokeStyle = 'rgb(255,0,0)';
            ctx.arc(ox + a * 10, y[i] + w / 2, 4, 0, 360);
            ctx.fillStyle = 'rgb(255,0,0)';
            ctx.fill();
            ctx.stroke();

            ctx.strokeStyle = 'rgb(255,0,0,0.5)';
            ctx.beginPath();
            ctx.moveTo(x[i] + w / 2, y[i] + w / 2);
            ctx.lineTo(ox + a * 10, y[i] + w / 2);
            ctx.stroke();

            S += Math.floor((oy - y[i] - h / 2) / (a * 10) * 100);
        }
        var M = S / NN;
        ctx.beginPath();
        ctx.lineWidth = 1;
        ctx.strokeStyle = 'rgb(255,0,0)';
        ctx.arc(ox + a * 10 + w / 2, oy - M * a / 10, 4, 0, 360);
        ctx.fillStyle = 'rgb(255,255,255)';
        ctx.fill();
        ctx.stroke();

    }
}
function DrawYY() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    PN = document.getElementById('PN_number').value;
    var YY, ZZ;
    var xx, yy;

    if (document.getElementById('Suportline').checked) {
        for (var i = 0; i < PN; i++) {
            ctx.beginPath();
            ctx.lineWidth = 1;
            ctx.strokeStyle = 'rgb(0,0,255)';

            xx = Math.floor((x[i] - ox + w / 2) / (a * 10) * 100);
            yy = Math.floor((oy - y[i] - h / 2) / (a * 10) * 100);

            YY = Math.floor(A * xx + B);
            ZZ = B - (YY - yy);

            ctx.arc(ox, oy - ZZ * a / 10, 4, 0, 360);
            ctx.fillStyle = 'rgb(0,0,255)';
            ctx.fill();
            ctx.stroke();

            ctx.strokeStyle = 'rgb(0,0,255,0.5)';
            ctx.beginPath();
            ctx.moveTo(x[i] + w / 2, y[i] + w / 2);
            ctx.lineTo(ox, oy - ZZ * a / 10);
            ctx.stroke();
        }

        ctx.beginPath();
        ctx.lineWidth = 1;
        ctx.strokeStyle = 'rgb(0,0,255)';
        ctx.arc(ox - w / 2, oy - B * a / 10, 4, 0, 360);
        ctx.fillStyle = 'rgb(255,255,255)';
        ctx.fill();
        ctx.stroke();
    }

}
function mainCorr() {
    var PN = document.getElementById('PN_number').value;
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');
    var isDragging = false;
    var dragTarget = null; // ドラッグ対象の画像の添え字

    setData();
    DrawAxis();

    s_calc_corr();
    images[PN - 1].addEventListener('load', function () {
        DrawPoint();
    }, false);
    DrawY();
    DrawYY();
    DrawLine();

    // ドラッグ開始
    var mouseDown = function (e) {
        // ドラッグ開始位置
        var posX = parseInt(e.clientX - canvas.getBoundingClientRect().left);
        var posY = parseInt(e.clientY - canvas.getBoundingClientRect().top);

        // for (var i = images.length - 1; i >= 0; i--) {
        var PN = document.getElementById('PN_number').value;
        for (var i = PN - 1; i >= 0; i--) {
            // 当たり判定（ドラッグした位置が画像の範囲内に収まっているか）
            if (posX >= images[i].drawOffsetX &&
                posX <= (images[i].drawOffsetX + images[i].drawWidth) &&
                posY >= images[i].drawOffsetY &&
                posY <= (images[i].drawOffsetY + images[i].drawHeight)
            ) {
                dragTarget = i;
                isDragging = true;
                break;
            }
        }
    }

    // ドラッグ終了
    var mouseUp = function (e) {
        isDragging = false;
    };

    // canvasの枠から外れた
    var mouseOut = function (e) {
        // canvas外にマウスカーソルが移動した場合に、ドラッグ終了としたい場合はコメントインする
        // mouseUp(e);
    };

    // ドラッグ中
    var mouseMove = function (e) {
        // ドラッグ終了位置
        var posX = parseInt(e.clientX - canvas.getBoundingClientRect().left);
        var posY = parseInt(e.clientY - canvas.getBoundingClientRect().top);

        if ((posX < ox) || (posX > ox + a * 10) || (posY < oy - a * 10) || (posY > oy)) {
            isDragging = false;
        }

        if ((posX > ox) && (posX < ox + a * 10) && (posY > oy) && (posY < oy + 18)) {
            DrawAxis();
            // DrawText(posX, posY);
            DrawY();
            DrawYY();
            DrawLine();
            DrawPoint();
        } else {
            DrawAxis();
            DrawY();
            DrawYY();
            DrawLine();
            DrawPoint();
        }

        if (isDragging) {
            var mx = 0;
            var my = 0;
            // for (var i in images) {
            var PN = document.getElementById('PN_number').value;
            for (var i = 0; i < PN; i++) {
                if (i == dragTarget) {
                    mx = posX - images[i].drawWidth / 2;
                    my = posY - images[i].drawHeight / 2;

                    // ドラッグが終了した時の情報を記憶
                    images[i].drawOffsetX = mx;
                    images[i].drawOffsetY = my;
                } else {
                    mx = images[i].drawOffsetX;
                    my = images[i].drawOffsetY;
                }
                w = images[i].drawWidth;
                h = images[i].drawHeight;

                x[i] = mx;
                y[i] = my;
            }

            DrawAxis();

            s_calc_corr();
            DrawY();
            DrawYY();
            DrawLine();

            DrawPoint();

        }
    };

    // canvasにイベント登録
    canvas.addEventListener('mousedown', function (e) { mouseDown(e); }, false);
    canvas.addEventListener('mousemove', function (e) { mouseMove(e); }, false);
    canvas.addEventListener('mouseup', function (e) { mouseUp(e); }, false);
    canvas.addEventListener('mouseout', function (e) { mouseOut(e); }, false);
}
function s_calc_corr() {
    var KK = 2;
    var M = [];
    var SD = [];
    PN = document.getElementById('PN_number').value;
    NN = PN;

    for (var i = 0; i < PN; i++) {
        xx[i][0] = Math.floor((x[i] - ox + w / 2) / (a * 10) * 100);
        xx[i][1] = Math.floor((oy - y[i] - h / 2) / (a * 10) * 100);
    }

    //基本統計量
    var S = 0;
    var SS = 0;
    for (j = 0; j < KK; j++) {
        S = 0;
        SS = 0;
        for (i = 0; i < NN; i++) {
            S += xx[i][j];
            SS += Math.pow(xx[i][j], 2);
        }
        M[j] = S / NN;
        SD[j] = Math.sqrt(SS / NN - Math.pow(M[j], 2));
    }

    var R = 0;
    var FF = 0;
    var F$ = "";

    var FF1, FF2, FF3;
    FF3 = f_tables(2, NN); //１％水準
    FF2 = f_tables(1, NN); //５％水準
    FF1 = f_tables(0, NN); //１０％水準

    S = 0;
    for (i = 0; i < NN; i++) {
        S += (xx[i][0] - M[0]) * (xx[i][1] - M[1]);
    }
    R = S / NN / SD[0] / SD[1];
    if (R > 0.9999) {
        if (Math.pow(R, 2) == 1) {
            FF = 0;
        } else {
            FF = 999.99;
        }
    } else {
        if (Math.pow(R, 2) == 1) {
            FF = 0;
        } else {
            FF = Math.pow(R, 2) / (1 - Math.pow(R, 2)) * (NN - 2);
        }
    }
    if (NN > 2) {
        if (FF > FF3) { //１％水準
            F$ = " ** (p<.01)";
        } else if (FF > FF2) { //５％水準
            F$ = " *  (p<.05)";
        } else if (FF > FF1) { //１０％水準
            F$ = " +  (.05<p<.10)";
        } else {
            F$ = " ns (.10<p)";
        }
    } else {
        F$ = " ns (.10<p)";
    }

    //回帰直線の傾き
    A = R * (SD[1] / SD[0]);
    //回帰直線の切片
    B = M[1] - A * M[0];

    //説明率
    var SS1 = 0;
    for (i = 0; i < PN; i++) {
        SS1 += Math.pow(xx[i][1] - M[1], 2);
    }
    var SS2 = 0;
    for (i = 0; i < PN; i++) {
        YY = A * xx[i][0] + B;
        SS2 += Math.pow(xx[i][1] - YY, 2);
    }
    var ExplanationRate = (1 - SS2 / SS1).toFixed(3);

    //結果出力
    document.getElementById("result").value = "r=" + R.toFixed(3) + "  説明率=" + ExplanationRate;

    //データ出力
    var corrData = [];
    for (i = 0; i < PN; i++) {
        corrData.push(xx[i][0] + "\t" + xx[i][1]);
    }
    document.getElementById("corrDataArea").value = corrData.join('\n');
    corrData = null;
}