/**
 * ｔ検定
 * Ts(参加者間)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeTsSetting();
	// ChangeAsInput(0);

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
	var i = 0;
	var LA = 2;
	var NN = [];
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
	}

	var elmCount = 0;
	for (i = 0; i < LA; i++) {
		elmCount += NN[i];
	}

	var result = confirm("データを消去します");
	if (result === true) {

		// Asには要因名があるが，Tsにはない
		// document.getElementById("factorA_name").value = "A";

		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	document.getElementById("cell_1").focus();
}
// 入力チェック
function checkCellData() {
	var i = 0;

	var LA = 2;
	var NN = [];

	var elmCount = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		elmCount += NN[i];
	}

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value === "") {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_Ts();
			//ノンパラ
			mainCalc_Median();
			mainCalc_Median2();
			mainCalc_Utest();
		} else {
			alert("すべての数値が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_Ts() {
	var i = 0;
	var j = 0;
	var ii = 0;

	var AA = "A";
	var LA = 2;
	var NN = [];

	var NX = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		if (NX < NN[i]) NX = NN[i];
	}

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NX);
	}

	var cellId = 1;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < NN[i]; j++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
		}
	}

	var M = new Array(NX); //平均
	var S2 = []; //分散
	var SD = []; //標準偏差

	var D_M = 0; //水準１と水準２の差の平均
	var D_S2 = 0; //水準１と水準２の差の分散
	var D_SD = 0; //水準１と水準２の差の標準偏差

	var strArray = [];
	var bar = "------------------------------------------------\n";

	//平均・標準偏差
	strArray.push("[ 対応のないｔ検定(Welch's t-Test) ]\n\n");
	strArray.push(" == Mean & S.D. ( SD=sqrt(Vtotal/N) ) ==\n\n");
	strArray.push(bar);
	strArray.push("        N      Mean      S.D.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		for (j = 0; j < NN[i]; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);
		}
		M[i] = S / NN[i];
		S2[i] = SS / NN[i] - Math.pow(M[i], 2);
		SD[i] = Math.sqrt(S2[i]);

		M[i] = parseFloat(M[i].toFixed(2));
		S2[i] = parseFloat(S2[i].toFixed(2));
		SD[i] = parseFloat(SD[i].toFixed(2));

		strArray.push(('群' + (i + 1) + NN[i].format(" ", 6) + M[i].format(" ", 10) + SD[i].format(" ", 10) + '\n'));
	}
	strArray.push(bar);

	//T値
	var T = Math.abs(M[0] - M[1]) / Math.sqrt(S2[0] / (NN[0] - 1) + S2[1] / (NN[1] - 1));
	T = parseFloat(T.toFixed(4));

	//自由度
	var wC = (S2[0] / (NN[0] - 1)) / (S2[0] / (NN[0] - 1) + S2[1] / (NN[1] - 1));
	var DF = (NN[0] - 1) * (NN[1] - 1) / ((NN[0] - 1) * Math.pow(1 - wC, 2) + (NN[1] - 1) * Math.pow(wC, 2));
	DF = Math.floor(DF);

	var PP2 = t_table(DF, T);

	var ppStr = "";
	if (PP2 === 0.01) {
		ppStr = "   ** (p<.01)";
	}
	if (PP2 === 0.05) {
		ppStr = "   *  (p<.05)";
	}
	if (PP2 === 0.10) {
		ppStr = "   +  (.05<p<.10)";
	}
	if (PP2 === 1) {
		ppStr = "   ns (.10<p)";
	}
	strArray.push((' t(' + DF + ')= ' + T + ' , ' + ppStr + '\n'));

	strArray.push(bar);
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	//グラフの設定
	var gCheck = document.getElementById("RltArea").value;
	gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム
	(function () {
		var rcmArray = [];
		var spc = "          ";

		rcmArray.push("#######　参加者間ｔ検定　#######\n");
		rcmArray.push("\n");
		rcmArray.push("# パッケージ pwr が必要\n");
		rcmArray.push("\n");
		rcmArray.push("## js-STARからの入力\n");
		for (i = 0; i < LA; i++) {
			rcmArray.push("g" + (i + 1) + " <- c(");
			for (j = 0; j < NN[i]; j++) {
				rcmArray.push(xx[i][j]);
				if (j < NN[i] - 1) rcmArray.push(", ");
			}
			rcmArray.push(") # 群" + (i + 1) + "\n");
		}

		rcmArray.push("shinrai=0.95 # 信頼水準\n");
		rcmArray.push("### js-STARからの入力おわり\n");

		rcmArray.push("\n");
		rcmArray.push("n1 <- length(g1)\n");
		rcmArray.push("n2 <- length(g2)\n");
		rcmArray.push("hk <- c(mean(g1), mean(g2))  # 平均\n");
		rcmArray.push("sd <- c(  sd(g1),   sd(g2))  # SD\n");
		rcmArray.push("mi <- c( min(g1),  min(g2))\n");
		rcmArray.push("ma <- c( max(g1),  max(g2))\n");

		rcmArray.push("\n");
		rcmArray.push("## 作図\n");
		rcmArray.push("mitsdo <- c( 0, 20 )         # バーの斜線密度\n");
		rcmArray.push("xjik <- c(0, 3)              # ｘ軸の範囲\n");
		rcmArray.push("bai  <- 2                    # ｙ軸の拡幅倍率\n");
		rcmArray.push("shoh <- min(min(hk),0)       # 最小平均か,ゼロ\n");
		rcmArray.push("dais <- max(sd)              # 最大ＳＤ\n");
		rcmArray.push("yjik <-c(shoh+dais*bai*sign(shoh),\n");
		rcmArray.push("         max(hk)+dais*bai)   # ｙ軸の範囲\n");
		rcmArray.push("\n");

		rcmArray.push("antx <- barplot(             # バーの中点ｘ座標を出力するので取得\n");
		rcmArray.push("        hk,                  # 平均値のバーを描画\n");
		rcmArray.push("        xli=xjik,  yli=yjik, # ｘ・ｙ軸の範囲\n");
		rcmArray.push("        las=1, tck=0.02,     # ｙ軸の目盛デザイン　※ tck 変更可\n");
		rcmArray.push("        col=1,               # バーの色番号（黒）　※番号変更可\n");
		rcmArray.push("        den=mitsdo,          # バーの斜線密度　　　※ mitsdo 変更可\n");
		rcmArray.push("        names.arg=c(");
		for (i = 0; i < LA; i++) {
			rcmArray.push("\"群" + (i + 1) + "\"");
			if (i < LA - 1) rcmArray.push(",");
		}
		rcmArray.push(")," + spc + " # 棒グラフの名前　※ 変更可\n");
		rcmArray.push("        xlab=\"\"," + spc + "    # ｘ軸のラベル名　※ 変更可\n");
		rcmArray.push("        ylab=\"\"," + spc + "    # ｙ軸のラベル名　※ 変更可\n");
		rcmArray.push("        main=c(\"SD = sqrt ( 全分散／(n-1) )\") )\n");
		rcmArray.push("\n");

		rcmArray.push("arrows(                                 # アロー（矢印）でアンテナを描く\n");
		rcmArray.push("       antx, hk, antx, hk+sd*sign(hk),  # 矢印の始点座標,終点座標を指定\n");
		rcmArray.push("       lwd=2, ang=90                    # 矢印の軸幅,矢羽の角度を指定\n");
		rcmArray.push("       )\n");

		rcmArray.push("\n");
		rcmArray.push("## 平均とＳＤ\n");
		rcmArray.push("tx0 <- c()\n");
		rcmArray.push("tx0 <- matrix(c(\n");
		rcmArray.push("  n1, n2,\n");
		rcmArray.push("  round(hk, 4),\n");
		rcmArray.push("  round(sd, 4),\n");
		rcmArray.push("  round(mi, 4),\n");
		rcmArray.push("  round(ma, 4)\n");
		rcmArray.push("  ), nr=2, by=0)\n");
		rcmArray.push("rownames(tx0) <- c(\"群１\",\"群２\")\n");
		rcmArray.push("colnames(tx0) <- c(\n");
		rcmArray.push("  \"  ｎ\",\n");
		rcmArray.push("  \"    Mean\",\n");
		rcmArray.push("  \"      SD\",\n");
		rcmArray.push("  \"    Min.\",\n");
		rcmArray.push("  \"    Max.\" )\n");

		rcmArray.push("\n");
		rcmArray.push("## 分散の同質性の検定：出力用テキスト te0\n");
		rcmArray.push("ke0 <- c()\n");
		rcmArray.push("ke0 <- var.test(g1, g2)  # 等分散の検定\n");
		rcmArray.push("\n");
		rcmArray.push("te0 <- c()\n");
		rcmArray.push("te0 <- matrix(c(\n");
		rcmArray.push("  round(ke0$stat, 4),\n");
		rcmArray.push("        ke0$para,\n");
		rcmArray.push("  round(ke0$p.va, 4),\n");
		rcmArray.push("  round(ke0$conf[1:2], 4)\n");
		rcmArray.push("  ), nr=1, by=1 )\n");
		rcmArray.push("rownames(te0) <- c(\"\")\n");
		rcmArray.push("colnames(te0) <- c(\n");
		rcmArray.push("  \"   Ｆ比\",\n");
		rcmArray.push("  \" df1\",\n");
		rcmArray.push("  \" df2\",\n");
		rcmArray.push("  \" 　ｐ値\",\n");
		rcmArray.push("  \"    下限値\",\"　上限値\")\n");
		rcmArray.push("\n");
		rcmArray.push("library( pwr ) # パワーアナリシス用\n");
		rcmArray.push("\n");

		rcmArray.push("\n");
		rcmArray.push("## ■１．両側・分散同質\n");
		rcmArray.push("H1  <- c(\"t\") # 対立仮説\n");
		rcmArray.push("\n");
		rcmArray.push("kx1 <- c()\n");
		rcmArray.push("kx1 <- t.test(\n");
		rcmArray.push("  g1, g2,\n");
		rcmArray.push("  var.eq=1,    # 分散同質\n");
		rcmArray.push("  conf=shinrai,# 95％信頼水準\n");
		rcmArray.push("  al=H1 ) \n");
		rcmArray.push("es  <- kx1$stat*sqrt(1/n1+1/n2) # 効果量d\n");
		rcmArray.push("\n");
		rcmArray.push("kx2 <- NA\n");
		rcmArray.push("kx2 <- c(\n");
		rcmArray.push("  pwr.t2n.test(al=H1, # power\n");
		rcmArray.push("  n1=n1, n2=n2,\n");
		rcmArray.push("  d =es,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=NULL )$po,\n");
		rcmArray.push("  kx2 )\n");
		rcmArray.push("\n");
		rcmArray.push("kx3 <- NA\n");
		rcmArray.push("kx3 <- c(\n");
		rcmArray.push("  pwr.t2n.test(al=H1, # si\n");
		rcmArray.push("  n1=n1, n2=n2,\n");
		rcmArray.push("  d =es,\n");
		rcmArray.push("  si=NULL,\n");
		rcmArray.push("  po=0.80 )$si,\n");
		rcmArray.push("  kx3 )\n");
		rcmArray.push("\n");
		rcmArray.push("kx4 <- NA\n");
		rcmArray.push("tmp <- ceiling((n1+n2)/2)\n");
		rcmArray.push("kx4 <- c(\n");
		rcmArray.push("  pwr.t2n.test(al=H1, # n2\n");
		rcmArray.push("  n1=tmp, n2=NULL,\n");
		rcmArray.push("  d =es,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=0.80 )$n2,\n");
		rcmArray.push("  kx4 )\n");
		rcmArray.push("tmp <- ceiling((tmp+kx4[1])/2)\n");
		rcmArray.push("kx4 <- c(\n");
		rcmArray.push("  pwr.t2n.test(al=H1,\n");
		rcmArray.push("  n1=tmp, n2=NULL,\n");
		rcmArray.push("  d =es,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=0.80 )$n2,\n");
		rcmArray.push("  kx4 )\n");
		rcmArray.push("tmp <- ceiling((tmp+kx4[1])/2)\n");
		rcmArray.push("kx4 <- NA\n");
		rcmArray.push("kx4 <- c(\n");
		rcmArray.push("  pwr.t2n.test(al=H1,\n");
		rcmArray.push("  n1=tmp, n2=NULL,\n");
		rcmArray.push("  d =es,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=0.80 )$n2,\n");
		rcmArray.push("  kx4 )\n");
		rcmArray.push("\n");
		rcmArray.push("## 両側・同質の出力\n");
		rcmArray.push("rd1 <- c()\n");
		rcmArray.push("rd1 <- matrix(c(\n");
		rcmArray.push("  round(kx1$stat, 4),\n");
		rcmArray.push("  round(kx1$para, 2),\n");
		rcmArray.push("  round(kx1$p.va, 4),\n");
		rcmArray.push("  round(kx2[1],   4)\n");
		rcmArray.push("  ), nr=1, by=1)\n");
		rcmArray.push("rownames(rd1) <- c(\"分散同質\")\n");
		rcmArray.push("colnames(rd1) <- c(\n");
		rcmArray.push("  \"    ｔ値\",\n");
		rcmArray.push("  \"      df\",\n");
		rcmArray.push("  \"    ｐ値\",\n");
		rcmArray.push("  \"  検出力\" )\n");
		rcmArray.push("\n");
		rcmArray.push("rd2 <- c()\n");
		rcmArray.push("rd2 <- matrix(c(\n");
		rcmArray.push("  round(mean(g1)-mean(g2), 4),\n");
		rcmArray.push("  round(kx1$conf[c(1,2)],  4)\n");
		rcmArray.push("  ), nr=1, by=1)\n");
		rcmArray.push("rownames(rd2) <- c(\"分散同質\")\n");
		rcmArray.push("colnames(rd2) <- c(\n");
		rcmArray.push("  \" 平均の差\",\n");
		rcmArray.push("  paste(\n");
		rcmArray.push("    \"  \",\n");
		rcmArray.push("    paste(\n");
		rcmArray.push("    shinrai*100,\n");
		rcmArray.push("    \"％信頼下限\", sep=\"\"),\n");
		rcmArray.push("  sep=\"\"),\n");
		rcmArray.push("    \"   信頼上限\" )\n");
		rcmArray.push("\n");
		rcmArray.push("rd3 <- matrix(c(\n");
		rcmArray.push("  round(es, 4),\n");
		rcmArray.push("  round(kx3[1], 4), # si\n");
		rcmArray.push("          0.80,\n");
		rcmArray.push("            n1,\n");
		rcmArray.push("            n2,\n");
		rcmArray.push("\n");
		rcmArray.push("  round(es, 4),\n");
		rcmArray.push("          0.05,\n");
		rcmArray.push("          0.80,\n");
		rcmArray.push("  ceiling(tmp),\n");
		rcmArray.push("  ceiling(kx4[1])\n");
		rcmArray.push("  ), nr=2, by=1)\n");
		rcmArray.push("rownames(rd3) <- c(\n");
		rcmArray.push("  \" α の計算\",\n");
		rcmArray.push("  \" ｎ の計算\" )\n");
		rcmArray.push("colnames(rd3) <- c(\n");
		rcmArray.push("  \" 効果量ｄ\",\n");
		rcmArray.push("  \"     α\",\n");
		rcmArray.push("  \" 1-β\",\n");
		rcmArray.push("  \"   n1\",\n");
		rcmArray.push("  \"   n2\" )\n");
		rcmArray.push("\n");
		rcmArray.push("# ■（２）両側・分散不等\n");
		rcmArray.push("H1  <- c(\"t\")\n");
		rcmArray.push("\n");
		rcmArray.push("kx1 <- c()\n");
		rcmArray.push("kx1 <- t.test(\n");
		rcmArray.push("  g1, g2,\n");
		rcmArray.push("  var.eq=0,    # 分散不等\n");
		rcmArray.push("  conf=shinrai,# 95％信頼水準\n");
		rcmArray.push("  al=H1 ) \n");
		rcmArray.push("es  <- kx1$stat*sqrt(1/n1+1/n2) # 効果量d\n");
		rcmArray.push("\n");
		rcmArray.push("kx2 <- NA\n");
		rcmArray.push("kx2 <- c(\n");
		rcmArray.push("  pwr.t2n.test(al=H1, # power\n");
		rcmArray.push("  n1=n1, n2=n2,\n");
		rcmArray.push("  d =es,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=NULL )$po,\n");
		rcmArray.push("  kx2 )\n");
		rcmArray.push("\n");
		rcmArray.push("kx3 <- NA\n");
		rcmArray.push("kx3 <- c(\n");
		rcmArray.push("  pwr.t2n.test(al=H1, # si\n");
		rcmArray.push("  n1=n1, n2=n2,\n");
		rcmArray.push("  d =es,\n");
		rcmArray.push("  si=NULL,\n");
		rcmArray.push("  po=0.80 )$si,\n");
		rcmArray.push("  kx3 )\n");
		rcmArray.push("\n");
		rcmArray.push("kx4 <- NA\n");
		rcmArray.push("tmp <- ceiling((n1+n2)/2)\n");
		rcmArray.push("kx4 <- c(\n");
		rcmArray.push("  pwr.t2n.test(al=H1, # n2\n");
		rcmArray.push("  n1=tmp, n2=NULL,\n");
		rcmArray.push("  d =es,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=0.80 )$n2,\n");
		rcmArray.push("  kx4 )\n");
		rcmArray.push("tmp <- ceiling((tmp+kx4[1])/2)\n");
		rcmArray.push("kx4 <- c(\n");
		rcmArray.push("  pwr.t2n.test(al=H1,\n");
		rcmArray.push("  n1=tmp, n2=NULL,\n");
		rcmArray.push("  d =es,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=0.80 )$n2,\n");
		rcmArray.push("  kx4 )\n");
		rcmArray.push("tmp <- ceiling((tmp+kx4[1])/2)\n");
		rcmArray.push("kx4 <- NA\n");
		rcmArray.push("kx4 <- c(\n");
		rcmArray.push("  pwr.t2n.test(al=H1,\n");
		rcmArray.push("  n1=tmp, n2=NULL,\n");
		rcmArray.push("  d =es,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=0.80 )$n2,\n");
		rcmArray.push("  kx4 )\n");
		rcmArray.push("\n");
		rcmArray.push("## 両側・不等の出力\n");
		rcmArray.push("rf1 <- c()\n");
		rcmArray.push("rf1 <- matrix(c(\n");
		rcmArray.push("  round(kx1$stat, 4),\n");
		rcmArray.push("  round(kx1$para, 2),\n");
		rcmArray.push("  round(kx1$p.va, 4),\n");
		rcmArray.push("  round( pt(\n");
		rcmArray.push("    qt(0.975, df=kx1$para),\n");
		rcmArray.push("    df=kx1$para,\n");
		rcmArray.push("    ncp=abs(kx1$stat),\n");
		rcmArray.push("   low=0), 4)\n");
		rcmArray.push("  ), nr=1, by=1)\n");
		rcmArray.push("rownames(rf1) <- c(\"分散不等\")\n");
		rcmArray.push("colnames(rf1) <- c(\n");
		rcmArray.push("  \"    ｔ値\",\n");
		rcmArray.push("  \"      df\",\n");
		rcmArray.push("  \"    ｐ値\",\n");
		rcmArray.push("  \"  検出力\" )\n");
		rcmArray.push("\n");
		rcmArray.push("rf2 <- c()\n");
		rcmArray.push("rf2 <- matrix(c(\n");
		rcmArray.push("  round(mean(g1)-mean(g2), 4),\n");
		rcmArray.push("  round(kx1$conf[c(1,2)],  4)\n");
		rcmArray.push("  ), nr=1, by=1)\n");
		rcmArray.push("rownames(rf2) <- c(\"分散不等\")\n");
		rcmArray.push("colnames(rf2) <- c(\n");
		rcmArray.push("  \" 平均の差\",\n");
		rcmArray.push("  paste(\n");
		rcmArray.push("    \"  \",\n");
		rcmArray.push("    paste(\n");
		rcmArray.push("    shinrai*100,\n");
		rcmArray.push("    \"％信頼下限\", sep=\"\"),\n");
		rcmArray.push("  sep=\"\"),\n");
		rcmArray.push("  \"   信頼上限\" )\n");
		rcmArray.push("\n");
		rcmArray.push("rf3 <- matrix(c(\n");
		rcmArray.push("  round(es, 4),\n");
		rcmArray.push("  round(kx3[1], 4), # si\n");
		rcmArray.push("          0.80,\n");
		rcmArray.push("            n1,\n");
		rcmArray.push("            n2,\n");
		rcmArray.push("\n");
		rcmArray.push("  round(es, 4),\n");
		rcmArray.push("          0.05,\n");
		rcmArray.push("          0.80,\n");
		rcmArray.push("  ceiling(tmp),\n");
		rcmArray.push("  ceiling(kx4[1])\n");
		rcmArray.push("  ), nr=2, by=1)\n");
		rcmArray.push("rownames(rf3) <- c(\n");
		rcmArray.push("  \" α の計算\",\n");
		rcmArray.push("  \" ｎ の計算\" )\n");
		rcmArray.push("colnames(rf3) <- c(\n");
		rcmArray.push("  \" 効果量ｄ\",\n");
		rcmArray.push("  \"     α\",\n");
		rcmArray.push("  \" 1-β\",\n");
		rcmArray.push("  \"   n1\",\n");
		rcmArray.push("  \"   n2\" )\n");
		rcmArray.push("\n");
		rcmArray.push("tr1 <- c()\n");
		rcmArray.push("tr1 <- rbind(rd1, rf1)\n");
		rcmArray.push("\n");
		rcmArray.push("tr2 <- c()\n");
		rcmArray.push("tr2 <- rbind(rd2, rf2)\n");

		if (M[0] - M[1] > 0) {
			rcmArray.push("\n");
			rcmArray.push("# ■（３）片側ｇ・分散同質\n");
			rcmArray.push("H1  <- c(\"g\")\n");
			rcmArray.push("\n");
			rcmArray.push("kx1 <- c()\n");
			rcmArray.push("kx1 <- t.test(\n");
			rcmArray.push("  g1, g2,\n");
			rcmArray.push("  var.eq=1,    # 分散同質\n");
			rcmArray.push("  conf=shinrai,# 95％信頼水準\n");
			rcmArray.push("  al=H1 ) \n");
			rcmArray.push("es  <- kx1$stat*sqrt(1/n1+1/n2) # 効果量d\n");
			rcmArray.push("\n");
			rcmArray.push("kx2 <- NA\n");
			rcmArray.push("kx2 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1, # power\n");
			rcmArray.push("  n1=n1, n2=n2,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=NULL )$po,\n");
			rcmArray.push("  kx2 )\n");
			rcmArray.push("\n");
			rcmArray.push("kx3 <- NA\n");
			rcmArray.push("kx3 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1, # si\n");
			rcmArray.push("  n1=n1, n2=n2,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=NULL,\n");
			rcmArray.push("  po=0.80 )$si,\n");
			rcmArray.push("  kx3 )\n");
			rcmArray.push("\n");
			rcmArray.push("kx4 <- NA\n");
			rcmArray.push("tmp <- ceiling((n1+n2)/2)\n");
			rcmArray.push("kx4 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1, # n2\n");
			rcmArray.push("  n1=tmp, n2=NULL,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=0.80 )$n2,\n");
			rcmArray.push("  kx4 )\n");
			rcmArray.push("tmp <- ceiling((tmp+kx4[1])/2)\n");
			rcmArray.push("kx4 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1,\n");
			rcmArray.push("  n1=tmp, n2=NULL,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=0.80 )$n2,\n");
			rcmArray.push("  kx4 )\n");
			rcmArray.push("tmp <- ceiling((tmp+kx4[1])/2)\n");
			rcmArray.push("kx4 <- NA\n");
			rcmArray.push("kx4 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1,\n");
			rcmArray.push("  n1=tmp, n2=NULL,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=0.80 )$n2,\n");
			rcmArray.push("  kx4 )\n");
			rcmArray.push("\n");
			rcmArray.push("# 片側ｇ・同質の出力\n");
			rcmArray.push("gd1 <- c()\n");
			rcmArray.push("gd1 <- matrix(c(\n");
			rcmArray.push("  round(kx1$stat, 4),\n");
			rcmArray.push("  round(kx1$para, 2),\n");
			rcmArray.push("  round(kx1$p.va, 4),\n");
			rcmArray.push("  round(kx2[1],   4)\n");
			rcmArray.push("  ), nr=1, by=1)\n");
			rcmArray.push("rownames(gd1) <- c(\"分散同質\")\n");
			rcmArray.push("colnames(gd1) <- c(\n");
			rcmArray.push("  \"    ｔ値\",\n");
			rcmArray.push("  \"      df\",\n");
			rcmArray.push("  \"    ｐ値\",\n");
			rcmArray.push("  \"  検出力\" )\n");
			rcmArray.push("\n");
			rcmArray.push("gd2 <- c()\n");
			rcmArray.push("gd2 <- matrix(c(\n");
			rcmArray.push("  round(mean(g1)-mean(g2), 4),\n");
			rcmArray.push("  round(kx1$conf[c(1,2)],  4)\n");
			rcmArray.push("  ), nr=1, by=1)\n");
			rcmArray.push("rownames(gd2) <- c(\"分散同質\")\n");
			rcmArray.push("colnames(gd2) <- c(\n");
			rcmArray.push("  \" 平均の差\",\n");
			rcmArray.push("  paste(\n");
			rcmArray.push("    \"  \",\n");
			rcmArray.push("    paste(\n");
			rcmArray.push("    shinrai*100,\n");
			rcmArray.push("    \"％信頼下限\", sep=\"\"),\n");
			rcmArray.push("  sep=\"\"),\n");
			rcmArray.push("  \"   信頼上限\" )\n");
			rcmArray.push("\n");
			rcmArray.push("gd3 <- matrix(c(\n");
			rcmArray.push("  round(es, 4),\n");
			rcmArray.push("  round(kx3[1], 4), # si\n");
			rcmArray.push("          0.80,\n");
			rcmArray.push("            n1,\n");
			rcmArray.push("            n2,\n");
			rcmArray.push("\n");
			rcmArray.push("  round(es, 4),\n");
			rcmArray.push("          0.05,\n");
			rcmArray.push("          0.80,\n");
			rcmArray.push("  ceiling(tmp),\n");
			rcmArray.push("  ceiling(kx4[1])\n");
			rcmArray.push("  ), nr=2, by=1)\n");
			rcmArray.push("rownames(gd3) <- c(\n");
			rcmArray.push("  \" α の計算\",\n");
			rcmArray.push("  \" ｎ の計算\" )\n");
			rcmArray.push("colnames(gd3) <- c(\n");
			rcmArray.push("  \" 効果量ｄ\",\n");
			rcmArray.push("  \"     α\",\n");
			rcmArray.push("  \" 1-β\",\n");
			rcmArray.push("  \"   n1\",\n");
			rcmArray.push("  \"   n2\" )\n");
			rcmArray.push("\n");
			rcmArray.push("# ■（４）片側ｇ・分散不等\n");
			rcmArray.push("H1  <- c(\"g\")\n");
			rcmArray.push("\n");
			rcmArray.push("kx1 <- c()\n");
			rcmArray.push("kx1 <- t.test(\n");
			rcmArray.push("  g1, g2,\n");
			rcmArray.push("  var.eq=0,    # 分散不等\n");
			rcmArray.push("  conf=shinrai,# 95％信頼水準\n");
			rcmArray.push("  al=H1 ) \n");
			rcmArray.push("es  <- kx1$stat*sqrt(1/n1+1/n2) # 効果量d\n");
			rcmArray.push("\n");
			rcmArray.push("kx2 <- NA\n");
			rcmArray.push("kx2 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1, # power\n");
			rcmArray.push("  n1=n1, n2=n2,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=NULL )$po,\n");
			rcmArray.push("  kx2 )\n");
			rcmArray.push("\n");
			rcmArray.push("kx3 <- NA\n");
			rcmArray.push("kx3 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1, # si\n");
			rcmArray.push("  n1=n1, n2=n2,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=NULL,\n");
			rcmArray.push("  po=0.80 )$si,\n");
			rcmArray.push("  kx3 )\n");
			rcmArray.push("\n");
			rcmArray.push("kx4 <- NA\n");
			rcmArray.push("tmp <- ceiling((n1+n2)/2)\n");
			rcmArray.push("kx4 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1, # n2\n");
			rcmArray.push("  n1=tmp, n2=NULL,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=0.80 )$n2,\n");
			rcmArray.push("  kx4 )\n");
			rcmArray.push("tmp <- ceiling((tmp+kx4[1])/2)\n");
			rcmArray.push("kx4 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1,\n");
			rcmArray.push("  n1=tmp, n2=NULL,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=0.80 )$n2,\n");
			rcmArray.push("  kx4 )\n");
			rcmArray.push("tmp <- ceiling((tmp+kx4[1])/2)\n");
			rcmArray.push("kx4 <- NA\n");
			rcmArray.push("kx4 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1,\n");
			rcmArray.push("  n1=tmp, n2=NULL,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=0.80 )$n2,\n");
			rcmArray.push("  kx4 )\n");
			rcmArray.push("\n");
			rcmArray.push("# 片側ｇ・不等の出力\n");
			rcmArray.push("gf1 <- c()\n");
			rcmArray.push("gf1 <- matrix(c(\n");
			rcmArray.push("  round(kx1$stat, 4),\n");
			rcmArray.push("  round(kx1$para, 2),\n");
			rcmArray.push("  round(kx1$p.va, 4),\n");
			rcmArray.push("  round( pt(\n");
			rcmArray.push("    qt(0.950, df=kx1$para),\n");
			rcmArray.push("    df=kx1$para,\n");
			rcmArray.push("    ncp=abs(kx1$stat),\n");
			rcmArray.push("    low=0), 4)\n");
			rcmArray.push("  ), nr=1, by=1)\n");
			rcmArray.push("rownames(gf1) <- c(\"分散不等\")\n");
			rcmArray.push("colnames(gf1) <- c(\n");
			rcmArray.push("  \"    ｔ値\",\n");
			rcmArray.push("  \"      df\",\n");
			rcmArray.push("  \"    ｐ値\",\n");
			rcmArray.push("  \"  検出力\" )\n");
			rcmArray.push("\n");
			rcmArray.push("gf2 <- c()\n");
			rcmArray.push("gf2 <- matrix(c(\n");
			rcmArray.push("  round(mean(g1)-mean(g2), 4),\n");
			rcmArray.push("  round(kx1$conf[c(1,2)],  4)\n");
			rcmArray.push("  ), nr=1, by=1)\n");
			rcmArray.push("rownames(gf2) <- c(\"分散不等\")\n");
			rcmArray.push("colnames(gf2) <- c(\n");
			rcmArray.push("  \" 平均の差\",\n");
			rcmArray.push("  paste(\n");
			rcmArray.push("    \"  \",\n");
			rcmArray.push("    paste(\n");
			rcmArray.push("    shinrai*100,\n");
			rcmArray.push("    \"％信頼下限\", sep=\"\"),\n");
			rcmArray.push("  sep=\"\"),\n");
			rcmArray.push("  \"   信頼上限\" )\n");
			rcmArray.push("\n");
			rcmArray.push("gf3 <- matrix(c(\n");
			rcmArray.push("  round(es, 4),\n");
			rcmArray.push("  round(kx3[1], 4), # si\n");
			rcmArray.push("          0.80,\n");
			rcmArray.push("            n1,\n");
			rcmArray.push("            n2,\n");
			rcmArray.push("\n");
			rcmArray.push("  round(es, 4),\n");
			rcmArray.push("          0.05,\n");
			rcmArray.push("          0.80,\n");
			rcmArray.push("  ceiling(tmp),\n");
			rcmArray.push("  ceiling(kx4[1])\n");
			rcmArray.push("  ), nr=2, by=1)\n");
			rcmArray.push("rownames(gf3) <- c(\n");
			rcmArray.push("  \" α の計算\",\n");
			rcmArray.push("  \" ｎ の計算\" )\n");
			rcmArray.push("colnames(gf3) <- c(\n");
			rcmArray.push("  \" 効果量ｄ\",\n");
			rcmArray.push("  \"     α\",\n");
			rcmArray.push("  \" 1-β\",\n");
			rcmArray.push("  \"   n1\",\n");
			rcmArray.push("  \"   n2\" )\n");
			rcmArray.push("\n");
			rcmArray.push("tg1 <- c()\n");
			rcmArray.push("tg1 <- rbind(gd1, gf1)\n");
			rcmArray.push("\n");
			rcmArray.push("tg2 <- c()\n");
			rcmArray.push("tg2 <- rbind(gd2, gf2)\n");
		}

		if (M[0] - M[1] < 0) {
			rcmArray.push("\n");
			rcmArray.push("# ■（５）片側ｌ・分散同質\n");
			rcmArray.push("H1  <- c(\"l\")\n");
			rcmArray.push("\n");
			rcmArray.push("kx1 <- c()\n");
			rcmArray.push("kx1 <- t.test(\n");
			rcmArray.push("  g1, g2,\n");
			rcmArray.push("  var.eq=1,    # 分散同質\n");
			rcmArray.push("  conf=shinrai,# 95％信頼水準\n");
			rcmArray.push("  al=H1 ) \n");
			rcmArray.push("es  <- kx1$stat*sqrt(1/n1+1/n2) # 効果量d\n");
			rcmArray.push("\n");
			rcmArray.push("kx2 <- NA\n");
			rcmArray.push("kx2 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1, # power\n");
			rcmArray.push("  n1=n1, n2=n2,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=NULL )$po,\n");
			rcmArray.push("  kx2 )\n");
			rcmArray.push("\n");
			rcmArray.push("kx3 <- NA\n");
			rcmArray.push("kx3 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1, # si\n");
			rcmArray.push("  n1=n1, n2=n2,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=NULL,\n");
			rcmArray.push("  po=0.80 )$si,\n");
			rcmArray.push("  kx3 )\n");
			rcmArray.push("\n");
			rcmArray.push("kx4 <- NA\n");
			rcmArray.push("tmp <- ceiling((n1+n2)/2)\n");
			rcmArray.push("kx4 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1, # n2\n");
			rcmArray.push("  n1=tmp, n2=NULL,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=0.80 )$n2,\n");
			rcmArray.push("  kx4 )\n");
			rcmArray.push("tmp <- ceiling((tmp+kx4[1])/2)\n");
			rcmArray.push("kx4 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1,\n");
			rcmArray.push("  n1=tmp, n2=NULL,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=0.80 )$n2,\n");
			rcmArray.push("  kx4 )\n");
			rcmArray.push("tmp <- ceiling((tmp+kx4[1])/2)\n");
			rcmArray.push("kx4 <- NA\n");
			rcmArray.push("kx4 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1,\n");
			rcmArray.push("  n1=tmp, n2=NULL,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=0.80 )$n2,\n");
			rcmArray.push("  kx4 )\n");
			rcmArray.push("\n");
			rcmArray.push("# 片側ｌ・同質の出力\n");
			rcmArray.push("ld1 <- c()\n");
			rcmArray.push("ld1 <- matrix(c(\n");
			rcmArray.push("  round(kx1$stat, 4),\n");
			rcmArray.push("  round(kx1$para, 2),\n");
			rcmArray.push("  round(kx1$p.va, 4),\n");
			rcmArray.push("  round(kx2[1],   4)\n");
			rcmArray.push("  ), nr=1, by=1)\n");
			rcmArray.push("rownames(ld1) <- c(\"分散同質\")\n");
			rcmArray.push("colnames(ld1) <- c(\n");
			rcmArray.push("  \"    ｔ値\",\n");
			rcmArray.push("  \"      df\",\n");
			rcmArray.push("  \"    ｐ値\",\n");
			rcmArray.push("  \"  検出力\" )\n");
			rcmArray.push("\n");
			rcmArray.push("ld2 <- c()\n");
			rcmArray.push("ld2 <- matrix(c(\n");
			rcmArray.push("  round(mean(g1)-mean(g2), 4),\n");
			rcmArray.push("  round(kx1$conf[c(1,2)],  4)\n");
			rcmArray.push("  ), nr=1, by=1)\n");
			rcmArray.push("rownames(ld2) <- c(\"分散同質\")\n");
			rcmArray.push("colnames(ld2) <- c(\n");
			rcmArray.push("  \" 平均の差\",\n");
			rcmArray.push("  paste(\n");
			rcmArray.push("    \"  \",\n");
			rcmArray.push("    paste(\n");
			rcmArray.push("    shinrai*100,\n");
			rcmArray.push("    \"％信頼下限\", sep=\"\"),\n");
			rcmArray.push("  sep=\"\"),\n");
			rcmArray.push("  \"   信頼上限\" )\n");
			rcmArray.push("\n");
			rcmArray.push("ld3 <- matrix(c(\n");
			rcmArray.push("  round(es, 4),\n");
			rcmArray.push("  round(kx3[1], 4), # si\n");
			rcmArray.push("          0.80,\n");
			rcmArray.push("            n1,\n");
			rcmArray.push("            n2,\n");
			rcmArray.push("\n");
			rcmArray.push("  round(es, 4),\n");
			rcmArray.push("          0.05,\n");
			rcmArray.push("          0.80,\n");
			rcmArray.push("  ceiling(tmp),\n");
			rcmArray.push("  ceiling(kx4[1])\n");
			rcmArray.push("  ), nr=2, by=1)\n");
			rcmArray.push("rownames(ld3) <- c(\n");
			rcmArray.push("  \" α の計算\",\n");
			rcmArray.push("  \" ｎ の計算\" )\n");
			rcmArray.push("colnames(ld3) <- c(\n");
			rcmArray.push("  \" 効果量ｄ\",\n");
			rcmArray.push("  \"     α\",\n");
			rcmArray.push("  \" 1-β\",\n");
			rcmArray.push("  \"   n1\",\n");
			rcmArray.push("  \"   n2\" )\n");
			rcmArray.push("\n");
			rcmArray.push("# ■（６）片側ｌ・分散不等\n");
			rcmArray.push("H1  <- c(\"l\")\n");
			rcmArray.push("\n");
			rcmArray.push("kx1 <- c()\n");
			rcmArray.push("kx1 <- t.test(\n");
			rcmArray.push("  g1, g2,\n");
			rcmArray.push("  var.eq=0,    # 分散不等\n");
			rcmArray.push("  conf=shinrai,# 95％信頼水準\n");
			rcmArray.push("  al=H1 ) \n");
			rcmArray.push("es  <- kx1$stat*sqrt(1/n1+1/n2) # 効果量d\n");
			rcmArray.push("\n");
			rcmArray.push("kx2 <- NA\n");
			rcmArray.push("kx2 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1, # power\n");
			rcmArray.push("  n1=n1, n2=n2,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=NULL )$po,\n");
			rcmArray.push("  kx2 )\n");
			rcmArray.push("\n");
			rcmArray.push("kx3 <- NA\n");
			rcmArray.push("kx3 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1, # si\n");
			rcmArray.push("  n1=n1, n2=n2,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=NULL,\n");
			rcmArray.push("  po=0.80 )$si,\n");
			rcmArray.push("  kx3 )\n");
			rcmArray.push("\n");
			rcmArray.push("kx4 <- NA\n");
			rcmArray.push("tmp <- ceiling((n1+n2)/2)\n");
			rcmArray.push("kx4 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1, # n2\n");
			rcmArray.push("  n1=tmp, n2=NULL,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=0.80 )$n2,\n");
			rcmArray.push("  kx4 )\n");
			rcmArray.push("tmp <- ceiling((tmp+kx4[1])/2)\n");
			rcmArray.push("kx4 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1,\n");
			rcmArray.push("  n1=tmp, n2=NULL,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=0.80 )$n2,\n");
			rcmArray.push("  kx4 )\n");
			rcmArray.push("tmp <- ceiling((tmp+kx4[1])/2)\n");
			rcmArray.push("kx4 <- NA\n");
			rcmArray.push("kx4 <- c(\n");
			rcmArray.push("  pwr.t2n.test(al=H1,\n");
			rcmArray.push("  n1=tmp, n2=NULL,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=0.80 )$n2,\n");
			rcmArray.push("  kx4 )\n");
			rcmArray.push("\n");
			rcmArray.push("# 片側ｌ・不等の出力\n");
			rcmArray.push("lf1 <- c()\n");
			rcmArray.push("lf1 <- matrix(c(\n");
			rcmArray.push("  round(kx1$stat, 4),\n");
			rcmArray.push("  round(kx1$para, 2),\n");
			rcmArray.push("  round(kx1$p.va, 4),\n");
			rcmArray.push("  round( pt(\n");
			rcmArray.push("    qt(0.950, df=kx1$para),\n");
			rcmArray.push("    df=kx1$para,\n");
			rcmArray.push("    ncp=abs(kx1$stat),\n");
			rcmArray.push("    low=0), 4)\n");
			rcmArray.push("  ), nr=1, by=1)\n");
			rcmArray.push("rownames(lf1) <- c(\"分散不等\")\n");
			rcmArray.push("colnames(lf1) <- c(\n");
			rcmArray.push("  \"    ｔ値\",\n");
			rcmArray.push("  \"      df\",\n");
			rcmArray.push("  \"    ｐ値\",\n");
			rcmArray.push("  \"  検出力\" )\n");
			rcmArray.push("\n");
			rcmArray.push("lf2 <- c()\n");
			rcmArray.push("lf2 <- matrix(c(\n");
			rcmArray.push("  round(mean(g1)-mean(g2), 4),\n");
			rcmArray.push("  round(kx1$conf[c(1,2)],  4)\n");
			rcmArray.push("  ), nr=1, by=1)\n");
			rcmArray.push("rownames(lf2) <- c(\"分散不等\")\n");
			rcmArray.push("colnames(lf2) <- c(\n");
			rcmArray.push("  \" 平均の差\",\n");
			rcmArray.push("  paste(\n");
			rcmArray.push("    \"  \",\n");
			rcmArray.push("    paste(\n");
			rcmArray.push("    shinrai*100,\n");
			rcmArray.push("    \"％信頼下限\", sep=\"\"),\n");
			rcmArray.push("  sep=\"\"),\n");
			rcmArray.push("  \"   信頼上限\" )\n");
			rcmArray.push("\n");
			rcmArray.push("lf3 <- matrix(c(\n");
			rcmArray.push("  round(es, 4),\n");
			rcmArray.push("  round(kx3[1], 4), # si\n");
			rcmArray.push("          0.80,\n");
			rcmArray.push("            n1,\n");
			rcmArray.push("            n2,\n");
			rcmArray.push("\n");
			rcmArray.push("  round(es, 4),\n");
			rcmArray.push("          0.05,\n");
			rcmArray.push("          0.80,\n");
			rcmArray.push("  ceiling(tmp),\n");
			rcmArray.push("  ceiling(kx4[1])\n");
			rcmArray.push("  ), nr=2, by=1)\n");
			rcmArray.push("rownames(lf3) <- c(\n");
			rcmArray.push("  \" α の計算\",\n");
			rcmArray.push("  \" ｎ の計算\" )\n");
			rcmArray.push("colnames(lf3) <- c(\n");
			rcmArray.push("  \" 効果量ｄ\",\n");
			rcmArray.push("  \"     α\",\n");
			rcmArray.push("  \" 1-β\",\n");
			rcmArray.push("  \"   n1\",\n");
			rcmArray.push("  \"   n2\" )\n");
			rcmArray.push("\n");
			rcmArray.push("tl1 <- c()\n");
			rcmArray.push("tl1 <- rbind(ld1, lf1)\n");
			rcmArray.push("\n");
			rcmArray.push("tl2 <- c()\n");
			rcmArray.push("tl2 <- rbind(ld2, lf2)\n");
		}

		if (M[0] - M[1] > 0) {
			rcmArray.push("\n");
			rcmArray.push("options(digits=5)\n");
			rcmArray.push("options(scipen=5)\n");
			rcmArray.push("###################################\n");
			rcmArray.push("# ２平均の有意差検定              #\n");
			rcmArray.push("# 　参加者間ｔ検定（片側 greater）#\n");
			rcmArray.push("# 　対立仮説：平均1－平均2＞０    #\n");
			rcmArray.push("###################################\n");
			rcmArray.push("tx0 # 基本統計量　※SDは不偏分散の平方根\n");
			rcmArray.push("\n");
			rcmArray.push("te0 # 分散の同質性検定と分散比の95％信頼区間推定\n");
			rcmArray.push("    #  p>α なら「真の分散比＝１」(→分散同質)\n");
			rcmArray.push("    #  p<α なら「真の分散比≠１」(→分散不等)\n");
			rcmArray.push("\n");
			rcmArray.push("tg1 # ｔ検定（分散不等はウェルチ法による）\n");
			rcmArray.push("    #  p<α なら「真の平均差＞０」\n");
			rcmArray.push("\n");
			rcmArray.push("tg2 # 平均の差の区間推定\n");
			rcmArray.push("\n");
			rcmArray.push("gd3 # パワーアナリシス（分散同質）\n");
			rcmArray.push("# 効果量ｄの評価：大=0.80, 中=0.50, 小=0.20\n");
			rcmArray.push("# ■ NULL, NA が表示されたときは計算不能■\n");
		}

		if (M[0] - M[1] < 0) {
			rcmArray.push("\n");
			rcmArray.push("options(digits=5)\n");
			rcmArray.push("options(scipen=5)\n");
			rcmArray.push("#################################\n");
			rcmArray.push("# ２平均の有意差検定            #\n");
			rcmArray.push("# 　参加者間ｔ検定（片側 less） #\n");
			rcmArray.push("# 　対立仮説：平均1－平均2＜０  #\n");
			rcmArray.push("#################################\n");
			rcmArray.push("tx0 # 基本統計量　※SDは不偏分散の平方根\n");
			rcmArray.push("\n");
			rcmArray.push("te0 # 分散の同質性検定と分散比の95％信頼区間推定\n");
			rcmArray.push("    #  p>α なら「真の分散比＝１」(→分散同質)\n");
			rcmArray.push("    #  p<α なら「真の分散比≠１」(→分散不等)\n");
			rcmArray.push("\n");
			rcmArray.push("tl1 # ｔ検定（分散不等はウェルチ法による）\n");
			rcmArray.push("    #  p<α なら「真の平均差＜０」\n");
			rcmArray.push("\n");
			rcmArray.push("tl2 # 平均の差の区間推定\n");
			rcmArray.push("\n");
			rcmArray.push("ld3 # パワーアナリシス（分散同質）\n");
			rcmArray.push("# 効果量ｄの評価：大=0.80, 中=0.50, 小=0.20\n");
			rcmArray.push("# ■ NULL, NA が表示されたときは計算不能■\n");
		}

		rcmArray.push("\n");
		rcmArray.push("options(digits=5)\n");
		rcmArray.push("options(scipen=5)\n");
		rcmArray.push("#################################\n");
		rcmArray.push("# ２平均の有意差検定            #\n");
		rcmArray.push("#   参加者間ｔ検定（両側）      #\n");
		rcmArray.push("#   対立仮説：平均1－平均2≠０  #\n");
		rcmArray.push("#################################\n");
		rcmArray.push("tx0 # 基本統計量　※SDは不偏分散の平方根\n");
		rcmArray.push("\n");
		rcmArray.push("te0 # 分散の同質性検定と分散比の95％信頼区間推定\n");
		rcmArray.push("    #  p>α なら「真の分散比＝１」(→分散同質)\n");
		rcmArray.push("    #  p<α なら「真の分散比≠１」(→分散不等)\n");
		rcmArray.push("\n");
		rcmArray.push("tr1 # ｔ検定（分散不等はウェルチ法による）\n");
		rcmArray.push("    #  p<α なら「真の平均差≠０」\n");
		rcmArray.push("\n");
		rcmArray.push("tr2 # 平均の差の区間推定\n");
		rcmArray.push("\n");
		rcmArray.push("rd3 # パワーアナリシス（分散同質）\n");
		rcmArray.push("# 効果量ｄの評価：大=0.80, 中=0.50, 小=0.20\n");
		rcmArray.push("# ■ NULL, NA が表示されたときは計算不能■\n");
		rcmArray.push("\n");
		rcmArray.push("# ○オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray.push("# windows();boxplot(g1,g2,las=1) # 箱ひげ図\n");

		rcmArray.push("\n");
		rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/");
		rcmArray.push("\n");

		document.getElementById("RcmArea").value = rcmArray.join("");
		rcmArray = null;
	}());	//Ｒプログラムここまで

	//グラフ描画
	(function () {
		chartClear();

		var i;
		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg0";
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var data = [];
		for (i = 0; i < LA; i++) {
			data[i] = parseFloat(M[i].toFixed(1), 10);
		}

		var max_y = M[0];
		var min_y = 0;
		for (i = 0; i < LA; i++) {
			if (max_y < M[i]) max_y = parseFloat(M[i].toFixed(1), 10);
			if (min_y > M[i]) min_y = parseFloat(M[i].toFixed(1), 10);
		}

		var _myMax = gCheck.match(/max:\d+/);
		if (_myMax !== null) {
			var myMax = _myMax[0].match(/\d+/);
			max_y = parseFloat(myMax, 10);
		}
		var _myMin = gCheck.match(/min:\d+/);
		if (_myMin !== null) {
			var myMin = _myMin[0].match(/\d+/);
			min_y = parseFloat(myMin, 10);
		}

		//カラーユニバーサルデザイン推奨配色セット制作委員会
		//https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
		var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

		var datasetKey = [];
		for (i = 0; i < 1; i++) {
			datasetKey[i] = [];
		}
		for (i = 0; i < 1; i++) {
			datasetKey[i].label = '群';
			datasetKey[i].data = data;
			datasetKey[i].backgroundColor = chartClrAry[i % chartClrAry.length];
			datasetKey[i].borderColor = chartClrAry[i % chartClrAry.length];
			datasetKey[i].pointBorderWidth = 3;
			datasetKey[i].borderWidth = 1;
			datasetKey[i].lineTension = 0;
		}

		var labelData = [];
		for (i = 0; i < LA; i++) {
			labelData.push('群' + (i + 1));
		}

		var datasetData = [];
		for (i = 0; i < 1; i++) {
			datasetData[i] = datasetKey[i];
		}

		var myChart = new Chart(ctx, {
			type: 'bar',
			data: {
				labels: labelData,
				datasets: datasetData
			},
			options: {
				scales: {
					xAxes: [{
						maxBarThickness: 30,
						ticks: {
						}
					}],
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right'
				},
				title: {
					display: true,
					text: 'Mean'
				}
			}
		});

		//箱ひげ図
		var addData = [];
		var myData = [];
		var arrayCol = [];
		for (i = 0; i < LA; i++) {
			arrayCol = [];
			for (j = 0; j < NN[i]; j++) {
				arrayCol.push(xx[i][j]);
			}
			myData.push(arrayCol);
		}

		chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg1";
		ctx = document.getElementById("chart").appendChild(chartImg);

		var boxplotData = {
			labels: labelData,
			datasets: [{
				label: 'A',
				backgroundColor: chartClrAry[0] + '33',
				borderColor: chartClrAry[0],
				borderWidth: 1,
				padding: 10,
				outlierRadius: 3,
				itemRadius: 3,
				outlierColor: '#999999',
				data: myData
			}]
		};

		var myChart2 = new Chart(ctx, {
			type: 'boxplot',
			data: boxplotData,
			options: {
				responsive: true,
				scales: {
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
				},
				title: {
					display: true,
					text: 'Boxplot'
				}
			}
		});
	}());	//グラフ描画ここまで

	document.getElementById("RcmArea").focus();
}
function changeTsSetting() {
	var h = 3;
	var htmArray = [];

	// htmArray.push("<div class=\"btnlayout\">");
	// htmArray.push("<ul class=\"menubutton\">");
	// htmArray.push("<li><a href=\"#\" onclick=\"clearCellData();\"><span>データ消去</span></a></li>");
	// htmArray.push("<li><input type=\"file\" class=\"file_input\" id=\"readFileData\" accept=\".txt,.csv\" onchange=\"readFile(this);\"><a href=\"#\" onclick=\"document.getElementById('readFileData').click();\"><span>データ読込</span></a></li>");
	// htmArray.push("</ul>");
	// htmArray.push("</div>");

	// freqdata2を使うか要検討 todo
	// htmArray.push("<div class=\"freqdata2\">");
	htmArray.push("<div class=\"tateyoko\">");
	htmArray.push("<table border=\"0\" class=\"codetb\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">群1 参加者数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"A1_subjNum\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeTsTable();\">");
	} else {
		htmArray.push("<select id=\"A1_subjNum\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'群１：参加者数');changeTsTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 3; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">群2 参加者数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"A2_subjNum\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeTsTable();\">");
	} else {
		htmArray.push("<select id=\"A2_subjNum\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'群２：参加者数');changeTsTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 3; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");

	document.getElementById("ts_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeTsTable();
}
function changeTsTable() {
	var i = 0;
	var j = 0;
	var LA = 2;
	var NN = [];

	var cellCount = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		cellCount += NN[i];
	}

	var htmArray = [];
	var cellId = 1;
	var sCount = 1;

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("群");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("データ");
	htmArray.push("</td>");
	htmArray.push("</tr>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<tr>");
		htmArray.push("<td ROWSPAN=\"" + NN[i] + "\" class=\"hyou_midashi_3d_title\">");
		htmArray.push("群" + (i + 1));
		htmArray.push("</td>");

		for (j = 0; j < NN[i]; j++) {
			if (j === 0) {
				htmArray.push("<td class=\"hyou_midashi_3d_top\">");
			} else {
				htmArray.push("<td class=\"hyou_midashi_3d\">");
			}
			htmArray.push(sCount);
			htmArray.push("</td>");
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum();\">");
			htmArray.push("</td>");
			htmArray.push("</tr>");
			cellId++;
			sCount++;
		}
	}

	htmArray.push("</table>");

	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("ts_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
// メディアン検定
function mainCalc_Median() {
	var i = 0;
	var j = 0;
	var ii = 0;

	var LA = 2;
	var NN = [];

	var NX = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		if (NX < NN[i]) NX = NN[i];
	}

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NX);
	}

	//メディアンを計算して，２×２にクロス集計
	var addedArray = [];
	var cellId = 1;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < NN[i]; j++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
			addedArray.push(xx[i][j]);
		}
	}
	var sortedArray = addedArray.sort(compareNumbers);
	var median = 0;
	if (sortedArray.length % 2 === 1) {
		median = sortedArray[(sortedArray.length - 1) / 2];
	} else {
		median = (sortedArray[sortedArray.length / 2 - 1] + sortedArray[sortedArray.length / 2]) / 2;
	}
	var countedArray = [];
	countedArray[0] = xx[0].filter(function (x) {
		if (x >= median) return x;
	});
	countedArray[1] = xx[1].filter(function (x) {
		if (x >= median) return x;
	});

	var DD1 = countedArray[0].length;
	var DD2 = NN[0] - DD1;
	var DD3 = countedArray[1].length;
	var DD4 = NN[1] - DD3;

	//2x2
	var A = DD1;
	var B = DD2;
	var C = DD3;
	var D = DD4;

	var M1 = A + B; //  A   B  | M1
	var M2 = C + D; //  C   D  | M2
	var M3 = B + D; //---------+----
	var M4 = A + C; //  M4  M3 | NN

	var NNN = A + B + C + D;
	//document.getElementById("cell_sum").value = NNN;

	var svA = A; //A～Dの値を保存(save)しておく
	var svB = B;
	var svC = C;
	var svD = D;

	var raA = (A / (A + B)).toFixed(4);  //A～Dの比率(ratio)
	var raB = (B / (A + B)).toFixed(4);
	var raC = (C / (C + D)).toFixed(4);
	var raD = (D / (C + D)).toFixed(4);

	var PP2 = 0; //両側確率
	var PP = 0;  //片側確率
	var K1 = 0;  //片側確率(計算１)
	var K2 = 0;  //片側確率(計算２)
	var wPP = []; //それぞれの場合のP値
	var KS = []; //交差 A*C-B*D

	var strArray = [];
	var rcmArray = [];

	var Dummy = 0;
	while ((M2 < M1) || (M3 < M1) || (M4 < M1)) { //M1が一番小さくなるまでABCDの値を変更する
		Dummy = A;
		A = B;
		B = Dummy;

		Dummy = A;
		A = D;
		D = Dummy;

		Dummy = A;
		A = C;
		C = Dummy;

		M1 = A + B;
		M2 = C + D;
		M3 = B + D;
		M4 = A + C;
	}

	var AA = A; //Aの値を保存しておく

	var LT = []; //logの値を代入して計算を高速化する
	var maxM = Math.max(M1, M2, M3, M4);
	for (i = 0; i < maxM + 1; i++) {
		LT[i] = logfact(i);
	}
	LT[NNN] = logfact(NNN);

	var iA, iB, iC, iD;
	var myConst = LT[M1] + LT[M2] + LT[M3] + LT[M4] - LT[NNN];
	for (iA = 0; iA < M1 + 1; iA++) {
		iB = M1 - iA;
		iC = M4 - iA;
		iD = M3 - iB;
		KS[iA] = iA * iD - iB * iC;
		wPP[iA] = Math.exp(myConst - LT[iA] - LT[iB] - LT[iC] - LT[iD]);
		wPP[iA] = wPP[iA] * 1000000000000000; //計算結果が16桁目に誤差がでるのを防ぐ
		wPP[iA] = Math.round(wPP[iA]);
		wPP[iA] = wPP[iA] / 1000000000000000;
	}

	for (iA = 0; iA < M1 + 1; iA++) {
		if (wPP[iA] <= wPP[AA]) {
			PP2 = PP2 + wPP[iA];
		}
		//交差で判断
		if (KS[AA] <= KS[iA]) {
			K1 = K1 + wPP[iA];
		}
		if (KS[AA] >= KS[iA]) {
			K2 = K2 + wPP[iA];
		}
	}

	var ppStr = "";
	if (PP2 < 0.01) {
		ppStr = "   ** (p<.01)";
	} else if (PP2 < 0.05) {
		ppStr = "   *  (p<.05)";
	} else if (PP2 < 0.10) {
		ppStr = "   +  (.05<p<.10)";
	} else {
		ppStr = "   ns (.10<p)";
	}

	strArray.push("[メディアン検定]\n\n");
	strArray.push("中央値　：　" + median + "\n\n");
	strArray.push("\t中央値以上\t中央値未満\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("群１\t" + DD1 + "\t" + DD2 + "\n");
	strArray.push("\t" + "(" + raA + ")" + "\t" + "(" + raB + ")" + "\n");
	strArray.push("群２\t" + DD3 + "\t" + DD4 + "\n");
	strArray.push("\t" + "(" + raC + ")" + "\t" + "(" + raD + ")" + "\n");
	strArray.push("-----------------------------------------" + "\n\n");
	strArray.push("両側検定  :  p=" + PP2.toFixed(4) + ppStr + "\n");

	if (K1 < K2) {
		PP = K1;
	} else {
		PP = K2;
	}

	var pp2Str = "";
	if (PP < 0.01) {
		pp2Str = "   ** (p<.01)";
	} else if (PP < 0.05) {
		pp2Str = "   *  (p<.05)";
	} else if (PP < 0.10) {
		pp2Str = "   +  (.05<p<.10)";
	} else {
		pp2Str = "   ns (.10<p)";
	}

	strArray.push("片側検定  :  p=" + PP.toFixed(4) + pp2Str + "\n\n");

	//Phiの計算（常に出力する）
	M1 = svA + svB;
	M2 = svC + svD;
	M3 = svA + svC;
	M4 = svB + svD;

	var Phi = Math.sqrt(Math.pow(svA * svD - svB * svC, 2) / (M1 * M2 * M3 * M4));
	var phi = Phi.toFixed(3);

	strArray.push("連関係数 : Phi=" + phi + "\n");

	//効果量の計算（常に出力する）
	var effectSizeH = 2 * Math.asin(Math.sqrt(raA)) - 2 * Math.asin(Math.sqrt(raC));
	strArray.push("効果量 : h=" + effectSizeH.toFixed(4) + "\n");
	strArray.push("\t\t（大=0.8 , 中=0.5 , 小=0.2）\n");

	// strArray.push("-----------------------------------------\n");
	// strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	//出力
	document.getElementById("RltArea").value += "\n\n" + strArray.join("");

	strArray = null;
}
function mainCalc_Median2() {
	var i = 0;
	var j = 0;
	var ii = 0;

	var LA = 2;
	var NN = [];

	var NX = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		if (NX < NN[i]) NX = NN[i];
	}

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NX);
	}

	var addedArray = [];
	var cellId = 1;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < NN[i]; j++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			addedArray.push(xx[i][j]);
			cellId++;
		}
	}

	var sortedArray = addedArray.sort(compareNumbers);
	console.log(sortedArray);

	var median = 0;
	if (sortedArray.length % 2 === 1) {
		median = sortedArray[(sortedArray.length - 1) / 2];
	} else {
		median = (sortedArray[sortedArray.length / 2 - 1] + sortedArray[sortedArray.length / 2]) / 2;
	}
	console.log(median);

	var countedArray = [];
	countedArray[0] = xx[0].filter(function (x) {
		if (x > median) return x;
	});
	countedArray[1] = xx[1].filter(function (x) {
		if (x > median) return x;
	});

	var DD1 = countedArray[0].length;
	var DD2 = NN[0] - DD1;
	var DD3 = countedArray[1].length;
	var DD4 = NN[1] - DD3;

	// var i = 0;

	var A = DD1;
	var B = DD2;
	var C = DD3;
	var D = DD4;

	var M1 = A + B; //  A   B  | M1
	var M2 = C + D; //  C   D  | M2
	var M3 = B + D; //---------+----
	var M4 = A + C; //  M4  M3 | NN

	var NNN = A + B + C + D;
	//document.getElementById("cell_sum").value = NNN;

	var svA = A; //A～Dの値を保存(save)しておく
	var svB = B;
	var svC = C;
	var svD = D;

	var raA = (A / (A + B)).toFixed(4);  //A～Dの比率(ratio)
	var raB = (B / (A + B)).toFixed(4);
	var raC = (C / (C + D)).toFixed(4);
	var raD = (D / (C + D)).toFixed(4);

	var PP2 = 0; //両側確率
	var PP = 0;  //片側確率
	var K1 = 0;  //片側確率(計算１)
	var K2 = 0;  //片側確率(計算２)
	var wPP = []; //それぞれの場合のP値
	var KS = []; //交差 A*C-B*D

	var strArray = [];
	var rcmArray = [];

	var Dummy = 0;
	while ((M2 < M1) || (M3 < M1) || (M4 < M1)) { //M1が一番小さくなるまでABCDの値を変更する
		Dummy = A;
		A = B;
		B = Dummy;

		Dummy = A;
		A = D;
		D = Dummy;

		Dummy = A;
		A = C;
		C = Dummy;

		M1 = A + B;
		M2 = C + D;
		M3 = B + D;
		M4 = A + C;
	}

	var AA = A; //Aの値を保存しておく

	var LT = []; //logの値を代入して計算を高速化する
	var maxM = Math.max(M1, M2, M3, M4);
	for (i = 0; i < maxM + 1; i++) {
		LT[i] = logfact(i);
	}
	LT[NNN] = logfact(NNN);

	var iA, iB, iC, iD;
	var myConst = LT[M1] + LT[M2] + LT[M3] + LT[M4] - LT[NNN];
	for (iA = 0; iA < M1 + 1; iA++) {
		iB = M1 - iA;
		iC = M4 - iA;
		iD = M3 - iB;
		KS[iA] = iA * iD - iB * iC;
		wPP[iA] = Math.exp(myConst - LT[iA] - LT[iB] - LT[iC] - LT[iD]);
		wPP[iA] = wPP[iA] * 1000000000000000; //計算結果が16桁目に誤差がでるのを防ぐ
		wPP[iA] = Math.round(wPP[iA]);
		wPP[iA] = wPP[iA] / 1000000000000000;
	}

	for (iA = 0; iA < M1 + 1; iA++) {
		if (wPP[iA] <= wPP[AA]) {
			PP2 = PP2 + wPP[iA];
		}
		//交差で判断
		if (KS[AA] <= KS[iA]) {
			K1 = K1 + wPP[iA];
		}
		if (KS[AA] >= KS[iA]) {
			K2 = K2 + wPP[iA];
		}
	}

	var ppStr = "";
	if (PP2 < 0.01) {
		ppStr = "   ** (p<.01)";
	} else if (PP2 < 0.05) {
		ppStr = "   *  (p<.05)";
	} else if (PP2 < 0.10) {
		ppStr = "   +  (.05<p<.10)";
	} else {
		ppStr = "   ns (.10<p)";
	}

	// strArray.push("[直接確率計算２×２]\n\n");
	strArray.push("\t中央値より大\t中央値以下\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("群１\t" + DD1 + "\t" + DD2 + "\n");
	strArray.push("\t" + "(" + raA + ")" + "\t" + "(" + raB + ")" + "\n");
	strArray.push("群２\t" + DD3 + "\t" + DD4 + "\n");
	strArray.push("\t" + "(" + raC + ")" + "\t" + "(" + raD + ")" + "\n");
	strArray.push("-----------------------------------------" + "\n\n");
	strArray.push("両側検定  :  p=" + PP2.toFixed(4) + ppStr + "\n");

	if (K1 < K2) {
		PP = K1;
	} else {
		PP = K2;
	}

	var pp2Str = "";
	if (PP < 0.01) {
		pp2Str = "   ** (p<.01)";
	} else if (PP < 0.05) {
		pp2Str = "   *  (p<.05)";
	} else if (PP < 0.10) {
		pp2Str = "   +  (.05<p<.10)";
	} else {
		pp2Str = "   ns (.10<p)";
	}

	strArray.push("片側検定  :  p=" + PP.toFixed(4) + pp2Str + "\n\n");

	//Phiの計算（常に出力する）
	M1 = svA + svB;
	M2 = svC + svD;
	M3 = svA + svC;
	M4 = svB + svD;

	var Phi = Math.sqrt(Math.pow(svA * svD - svB * svC, 2) / (M1 * M2 * M3 * M4));
	var phi = Phi.toFixed(3);

	strArray.push("連関係数 : Phi=" + phi + "\n");

	//効果量の計算（常に出力する）
	var effectSizeH = 2 * Math.asin(Math.sqrt(raA)) - 2 * Math.asin(Math.sqrt(raC));
	strArray.push("効果量 : h=" + effectSizeH.toFixed(4) + "\n");
	strArray.push("\t\t（大=0.8 , 中=0.5 , 小=0.2）\n");

	strArray.push("-----------------------------------------\n");
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	//出力
	document.getElementById("RltArea").value += "\n\n" + strArray.join("");
	strArray = null;
}
// マン・ホイットニーU検定
function mainCalc_Utest() {
	var i = 0;
	var j = 0;
	var ii = 0;

	var LA = 2;
	var NN = [];

	var NX = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		if (NX < NN[i]) NX = NN[i];
	}

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NX);
	}

	var a = [[], []];
	var cellId = 1;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < NN[i]; j++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
			a[i].push(xx[i][j]);
		}
	}

	//平均，標準偏差
	var M = [];
	var SD = [];

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		for (j = 0; j < NN[i]; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);
		}
		M[i] = S / NN[i];
		SD[i] = Math.sqrt(SS / NN[i] - Math.pow(M[i], 2));

		M[i] = parseFloat(M[i].toFixed(2));
		SD[i] = parseFloat(SD[i].toFixed(2));
	}

	//最大値，最小値
	var MAX = [];
	var MIN = [];
	for (i = 0; i < LA; i++) {
		MAX[i] = xx[i][0];
		MIN[i] = xx[i][0];
		for (j = 0; j < NN[i]; j++) {
			if (MAX[i] < xx[i][j]) MAX[i] = xx[i][j];
			if (MIN[i] > xx[i][j]) MIN[i] = xx[i][j];
		}
	}

	var N = [0, 0];
	N[0] = a[0].length;
	N[1] = a[1].length;

	var addedArray = a[0].concat(a[1]);
	var sortedArray = addedArray.sort(compareNumbers);
	var rankedArray = [];
	for (i = 0; i < sortedArray.length; i++) {
		rankedArray[i] = i + 1;
	}

	for (i = 1; i < sortedArray.length; i++) {
		if (sortedArray[i] === sortedArray[i - 1]) {
			rankedArray[i] = rankedArray[i - 1];
		}
	}

	var countedArray = [];
	for (i = 0; i < rankedArray.length; i++) {
		countedArray[i] = 0;
		for (j = 0; j < rankedArray.length; j++) {
			if (rankedArray[i] === rankedArray[j]) {
				countedArray[i]++;
			}
		}
	}

	var rerankedArray = [];
	for (i = 0; i < rankedArray.length; i++) {
		rerankedArray[i] = (rankedArray[i] * 2 + countedArray[i] - 1) / 2;
	}

	var trankedArray = [[], []];
	for (i = 0; i < sortedArray.length; i++) {
		for (var j1 = 0; j1 < a[0].length; j1++) {
			if (sortedArray[i] === a[0][j1]) {
				trankedArray[0][j1] = rerankedArray[i];
			}
		}
		for (var j2 = 0; j2 < a[1].length; j2++) {
			if (sortedArray[i] === a[1][j2]) {
				trankedArray[1][j2] = rerankedArray[i];
			}
		}
	}

	var R = [0, 0];
	for (j = 0; j < 2; j++) {
		for (i = 0; i < trankedArray[j].length; i++) {
			R[j] = R[j] + trankedArray[j][i];
		}
	}

	var U1 = 0;
	var U2 = 0;
	U1 = N[0] * N[1] + (N[0] * (N[0] + 1) / 2) - R[0];
	U2 = N[0] * N[1] - U1;

	var U = U1;
	if (U1 > U2) U = U2;

	var uM = N[0] * N[1] / 2;
	var uSD = Math.sqrt(N[0] * N[1] * (N[0] + N[1] + 1) / 12);
	var z = parseFloat(Math.abs((U - uM) / uSD).toFixed(2));

	var strArray = [];
	strArray.push("[マン・ホイットニーU検定]\n\n");
	strArray.push(" == Mean & S.D. ( SD=sqrt(Vtotal/N) ) ==\n\n");
	strArray.push("         N      Mean      S.D.       MAX       MIN\n");
	strArray.push("------------------------------------------------------\n");
	strArray.push(('群１' + N[0].format(" ", 6) + M[0].format(" ", 10) + SD[0].format(" ", 10) + MAX[0].format(" ", 10) + MIN[0].format(" ", 10) + "\n"));
	strArray.push(('群２' + N[1].format(" ", 6) + M[1].format(" ", 10) + SD[1].format(" ", 10) + MAX[1].format(" ", 10) + MIN[1].format(" ", 10) + "\n"));
	strArray.push("------------------------------------------------------\n\n");

	var ppStr = "";
	var PP2 = 0;
	if (N[0] <= 20 && N[1] <= 20) {
		strArray.push('         N    平均順位    統計量U\n');
		strArray.push("-----------------------------------------\n");
		strArray.push('群１' + N[0].format(" ", 6) + R[0].format(" ", 10) + U1.format(" ", 10) + '\n');
		strArray.push('群２' + N[1].format(" ", 6) + R[1].format(" ", 10) + U2.format(" ", 10) + '\n');
		strArray.push("-----------------------------------------\n");
		strArray.push('統計量U  ：' + U.format(" ", 6) + '\n');

		PP2 = U_tables(N[0], N[1], U);
		if (PP2 === 9) {
			strArray.push("データ数が少ないため，計算できません\n");
		} else {
			if (PP2 === 0.01) {
				ppStr = "   ** (p<.01)";
			}
			if (PP2 === 0.05) {
				ppStr = "   *  (p<.05)";
			}
			if (PP2 === 1) {
				ppStr = "   ns (.10<p)";
			}
			strArray.push("両側検定  :" + ppStr + "\n");
		}
	} else {
		var wSD = parseFloat(uSD.toFixed(2));
		strArray.push('平均E(U)  分散V(U)   統計量U    統計量z\n');
		strArray.push("-----------------------------------------\n");
		strArray.push(uM.format(" ", 8) + wSD.format(" ", 10) + U.format(" ", 10) + z.format(" ", 10) + '\n');
		strArray.push("-----------------------------------------\n");

		PP2 = z_tables(z);
		if (PP2 < 0.01) {
			ppStr = "   ** (p<.01)";
		} else if (PP2 < 0.05) {
			ppStr = "   *  (p<.05)";
		} else if (PP2 < 0.10) {
			ppStr = "   +  (.05<p<.10)";
		} else {
			ppStr = "   ns (.10<p)";
		}
		strArray.push("両側検定  :  p=" + PP2.toFixed(4) + ppStr + "\n");
	}

	strArray.push("-----------------------------------------\n");
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	// //出力
	document.getElementById("RltArea").value += "\n\n" + strArray.join("");
	strArray = null;



	document.getElementById("RltArea").focus();
}
function saveData_Ts() {
	var i, j;

	var strArray = [];

	var LA = 2;
	var NN = [];
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
	}

	//#0
	strArray.push("Ts" + "\n");
	//#1
	strArray.push("#" + "\n");
	for (i = 0; i < LA; i++) {
		if (i !== LA - 1) {
			strArray.push(NN[i] + ",");
		} else {
			strArray.push(NN[i]);
		}
	}
	strArray.push("\n");
	//#2
	strArray.push("#" + "\n");
	var cellId = 1;
	var x;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < NN[i]; j++) {
			x = document.getElementById("cell_" + cellId).value;
			strArray.push(x + "\n");
			cellId++;
		}
	}

	var Stream = strArray.join("");
	var fineName = "Ts_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_Ts() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "Ts") {
		var LA = 2;
		var nn_text = crDel(dd[1]);
		var NN = [];
		NN = nn_text.split(",");
		for (i = 0; i < LA; i++) {
			document.getElementById("A" + (i + 1) + "_subjNum").value = parseInt(NN[i], 10);
		}
		changeTsTable();
		document.getElementById("CandPArea").value = delTopCR(dd[2]);
	}
}